#include "mainwindow.h"
#include "ui_mainwindow.h"

const static int pos_min_x=0;
const static int pos_max_x=550;
const static int pos_min_y = 0;
const static int pos_max_y = 41;
MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

}
MainWindow::MainWindow(QString chttrans,QString punc,QString fullwidth,QString vk,QString remind) :
    ui(new Ui::MainWindow)
{

    ui->setupUi(this);
    setWindowFlags(Qt::FramelessWindowHint |Qt::WindowStaysOnTopHint );
    qDebug()<<QCursor::pos().rx();
    qDebug()<<QCursor::pos().ry();
    this->chttrans=chttrans;
    this->punc=punc;
    this->fullwidth=fullwidth;
    this->vk=vk;
    this->remind=remind;
  /*  if(chttrans=="true")
        this->chttrans="1";
    else
        this->chttrans="0";

    if(punc=="true")
        this->punc="1";
    else
        this->punc="0";

    if(fullwidth=="true")
        this->fullwidth="1";
    else
        this->fullwidth="0";

    if(vk=="true")
        this->vk="1";
    else
        this->vk="0";

    if(remind=="true")
        this->remind="1";
    else
         this->remind="0";
*/
    this->move(QCursor::pos().rx()-240,QCursor::pos().ry()-270);
    init();
}
void MainWindow::init()
{
    QString pic_path;
    pic_path=":/new/prefix1/"+this->chttrans+this->punc+this->fullwidth+this->vk+this->remind+".png";
    QPalette pal(this->palette());
    //设置背景黑色
    pal.setColor(QPalette::Background, Qt::white);
    this->setAutoFillBackground(true);
    this->setPalette(pal);
    ui->titlelable->setText(tr("icon"));
    ui->previewlable->setText(tr("preview"));
	ui->recover->setText(tr("recover default settings"));
	ui->saveBtn->setText(tr("confirm"));
    ui->checkBox_chttrans->setStyleSheet(
               "QCheckBox::indicator:unchecked {image: url(:/new/prefix1/check_n.png);}"
               "QCheckBox::indicator:checked {image: url(:/new/prefix1/check_y.png);}"
    );
    ui->checkBox_punc->setStyleSheet(
               "QCheckBox::indicator:unchecked {image: url(:/new/prefix1/check_n.png);}"
               "QCheckBox::indicator:checked {image: url(:/new/prefix1/check_y.png);}"
    );
    ui->checkBox_fullwidth->setStyleSheet(
               "QCheckBox::indicator:unchecked {image: url(:/new/prefix1/check_n.png);}"
               "QCheckBox::indicator:checked {image: url(:/new/prefix1/check_y.png);}"
    );
    ui->checkBox_vk->setStyleSheet(
               "QCheckBox::indicator:unchecked {image: url(:/new/prefix1/check_n.png);}"
               "QCheckBox::indicator:checked {image: url(:/new/prefix1/check_y.png);}"
    );
    ui->checkBox_remind->setStyleSheet(
               "QCheckBox::indicator:unchecked {image: url(:/new/prefix1/check_n.png);}"
               "QCheckBox::indicator:checked {image: url(:/new/prefix1/check_y.png);}"
    );
    ui->checkBox_chttrans->setFocusPolicy(Qt::NoFocus);
    ui->checkBox_fullwidth->setFocusPolicy(Qt::NoFocus);
    ui->checkBox_punc->setFocusPolicy(Qt::NoFocus);
    ui->checkBox_remind->setFocusPolicy(Qt::NoFocus);
    ui->checkBox_vk->setFocusPolicy(Qt::NoFocus);
    ui->saveBtn->setFocusPolicy(Qt::NoFocus);

    if(this->chttrans=="1")
        ui->checkBox_chttrans->setChecked(true);
    else
        ui->checkBox_chttrans->setChecked(false);

    if(this->punc=="1")
        ui->checkBox_punc->setChecked(true);
    else
        ui->checkBox_punc->setChecked(false);
    if(this->fullwidth=="1")
       ui->checkBox_fullwidth->setChecked(true);
    else
        ui->checkBox_fullwidth->setChecked(false);
    if(this->vk=="1")
        ui->checkBox_vk->setChecked(true);
    else
        ui->checkBox_vk->setChecked(false);
    if(this->remind=="1")
        ui->checkBox_remind->setChecked(true);
    else
        ui->checkBox_remind->setChecked(false);

    pixmap=new QPixmap;
    pixmap->load(pic_path);
    ui->previewimage->setPixmap(*pixmap);
    ui->previewimage->resize(pixmap->width(),pixmap->height());
}
void MainWindow::paintEvent(QPaintEvent *e)
{
       QPainterPath path1;
       path1.setFillRule(Qt::WindingFill);
       path1.addRect(4, 4, this->width()-8, this->height()-8);
       QPainter painter(this);
       painter.eraseRect(0,0,this->width(),this->height());
       painter.setRenderHint(QPainter::Antialiasing);
       painter.fillPath(path1, QBrush(QColor(255, 255, 255)));
       QColor color(41, 36, 33, 50);
       for(int i=0; i<4; i++)
       {
           QPainterPath path;
           path.setFillRule(Qt::WindingFill);
           path.addRect(4-i, 4-i, this->width()-(4-i)*2, this->height()-(4-i)*2);
           color.setAlpha(90 - sqrt(i)*40);
           painter.setPen(color);
           painter.drawPath(path);
       }

}
/*
**函数功能：重写鼠标按下事件，记住鼠标左键在主界面内按下的坐标
*/
void MainWindow::mousePressEvent(QMouseEvent *event)
{

    mousePosition=event->pos();

    if(mousePosition.x()<=pos_min_x)
        return;
    if (mousePosition.x()>=pos_max_x)
        return;
    if (mousePosition.y()<=pos_min_y)
        return;
    if (mousePosition.y()>=pos_max_y)
        return;
    isMousePressed = true;
}
/*
**函数功能：重写鼠标移动事件，移送窗口到鼠标当前坐标位置
*/
void MainWindow::mouseMoveEvent(QMouseEvent *event)
{
    if (isMousePressed==true)
    {
        QPoint movePot=event->globalPos()-mousePosition;
        move(movePot);
    }
}
/*
**函数功能：重写鼠标按键抬起事件，当鼠标按键抬起，不再移动窗口
*/
void MainWindow::mouseReleaseEvent(QMouseEvent *event)
{

    isMousePressed=false;
}
MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_pushButton_clicked()
{
    this->close();
    QApplication::exit();
}

void MainWindow::on_recover_clicked()
{
    ui->checkBox_chttrans->setChecked(true);
    ui->checkBox_punc->setChecked(true);
    ui->checkBox_fullwidth->setChecked(true);
    ui->checkBox_vk->setChecked(true);
    ui->checkBox_remind->setChecked(true);
}

void MainWindow::on_saveBtn_clicked()
{
    QString checkbox_result;
    QString fullwidth_result,punc_result,vk_result,chrrrans_result,remind_result;
    if(ui->checkBox_chttrans->isChecked())
    {
        chrrrans_result="true";
    }
    else
    {
        chrrrans_result="false";
    }
    if(ui->checkBox_punc->isChecked())
    {
        punc_result="true";
    }
    else
    {
        punc_result="false";
    }
    if(ui->checkBox_fullwidth->isChecked())
    {
        fullwidth_result="true";
    }
    else
    {
        fullwidth_result="false";
    }
    if(ui->checkBox_vk->isChecked())
    {
        vk_result="true";
    }
    else
    {
        vk_result="false";
    }
    if(ui->checkBox_remind->isChecked())
    {
        remind_result="true";
    }
    else
    {
        remind_result="false";
    }

    checkbox_result="chttrans:"+chrrrans_result;
    checkbox_result=checkbox_result+";punc:"+punc_result;
    checkbox_result=checkbox_result+";fullwidth:"+fullwidth_result;
    checkbox_result=checkbox_result+";vk:"+vk_result;
    checkbox_result=checkbox_result+";remind:"+remind_result;
    qDebug()<<"checkbox_resule:"<<checkbox_result;
    saveSettingToFile(checkbox_result);
    QApplication::exit();
}
void MainWindow::saveSettingToFile(QString result)
{
    QString user_name=getUserName();
    QString file_path;
    if(user_name=="root")
        file_path="/root"+user_config_filepath;
    else
        file_path="/home/"+user_name+user_config_filepath;
    qDebug()<<file_path;
    QFile f(file_path);
    if(!f.open(QIODevice::WriteOnly | QIODevice::Text))
    {
        qDebug()<< "Open failed.";
        return;
    }
    QTextStream txtOutput(&f);
    txtOutput << result << endl;
    f.close();
}

QString MainWindow::getUserName()
{
    QStringList envList;
    envList << "USERNAME.*" << "USER.*" << "USERDOMAIN.*"
            << "HOSTNAME.*" << "DOMAINNAME.*";
    QStringList environment = QProcess::systemEnvironment();
    foreach (QString string, envList)
    {
        int index = environment.indexOf(QRegExp(string));
        if(index != -1)
        {
            QStringList stringList = environment.at(index).split('=');
            if(stringList.size() == 2)
            {
                return stringList.at(1);
                break;
            }
        }
    }

    return "";
}



void MainWindow::on_checkBox_fullwidth_stateChanged(int arg1)
{
    QString pic_path;
    if(arg1==2)
    {
        this->fullwidth="1";
    }
    else
    {
        this->fullwidth="0";
    }
    pixmap=new QPixmap;
    pic_path=":/new/prefix1/"+this->chttrans+this->punc+this->fullwidth+this->vk+this->remind+".png";
    qDebug()<<pic_path;
    pixmap->load(pic_path);
    qDebug()<<"2112:"<<pixmap->width()<<"ss:"<<pixmap->height();
    ui->previewimage->setPixmap(*pixmap);
    if(pixmap->width()>=140)
      ui->previewimage->setGeometry(40,170,pixmap->width(),pixmap->height());
    else
        ui->previewimage->setGeometry(60,170,pixmap->width(),pixmap->height());

}

void MainWindow::on_checkBox_punc_stateChanged(int arg1)
{
    QString pic_path;
    if(arg1==2)
    {
        this->punc="1";

    }
    else
    {
        this->punc="0";
    }
    pixmap=new QPixmap;
    pic_path=":/new/prefix1/"+this->chttrans+this->punc+this->fullwidth+this->vk+this->remind+".png";
    qDebug()<<pic_path;
    pixmap->load(pic_path);
    qDebug()<<"2112:"<<pixmap->width()<<"ss:"<<pixmap->height();
    ui->previewimage->setPixmap(*pixmap);
    if(pixmap->width()>=140)
      ui->previewimage->setGeometry(40,170,pixmap->width(),pixmap->height());
    else
        ui->previewimage->setGeometry(60,170,pixmap->width(),pixmap->height());
}

void MainWindow::on_checkBox_vk_stateChanged(int arg1)
{
    QString pic_path;
    if(arg1==2)
    {
        this->vk="1";
    }
    else
    {
        this->vk="0";
    }
    pixmap=new QPixmap;
    pic_path=":/new/prefix1/"+this->chttrans+this->punc+this->fullwidth+this->vk+this->remind+".png";
    qDebug()<<pic_path;
    pixmap->load(pic_path);
    qDebug()<<"2112:"<<pixmap->width()<<"ss:"<<pixmap->height();
    ui->previewimage->setPixmap(*pixmap);
    if(pixmap->width()>=140)
      ui->previewimage->setGeometry(40,170,pixmap->width(),pixmap->height());
    else
        ui->previewimage->setGeometry(60,170,pixmap->width(),pixmap->height());
}

void MainWindow::on_checkBox_chttrans_stateChanged(int arg1)
{
    QString pic_path;
    if(arg1==2)
    {
        this->chttrans="1";

    }
    else
    {
        this->chttrans="0";
    }
    pixmap=new QPixmap;
    pic_path=":/new/prefix1/"+this->chttrans+this->punc+this->fullwidth+this->vk+this->remind+".png";
    qDebug()<<pic_path;
    pixmap->load(pic_path);
    qDebug()<<"2112:"<<pixmap->width()<<"ss:"<<pixmap->height();
    ui->previewimage->setPixmap(*pixmap);
    if(pixmap->width()>=140)
      ui->previewimage->setGeometry(40,170,pixmap->width(),pixmap->height());
    else
        ui->previewimage->setGeometry(60,170,pixmap->width(),pixmap->height());
}

void MainWindow::on_checkBox_remind_stateChanged(int arg1)
{
    QString pic_path;
    if(arg1==2)
    {
        this->remind="1";

    }
    else
    {
        this->remind="0";
    }
    pixmap=new QPixmap;
    pic_path=":/new/prefix1/"+this->chttrans+this->punc+this->fullwidth+this->vk+this->remind+".png";
    qDebug()<<pic_path;
    pixmap->load(pic_path);
    qDebug()<<"2112:"<<pixmap->width()<<"ss:"<<pixmap->height();
    ui->previewimage->setPixmap(*pixmap);
    if(pixmap->width()>=140)
      ui->previewimage->setGeometry(40,170,pixmap->width(),pixmap->height());
    else
        ui->previewimage->setGeometry(60,170,pixmap->width(),pixmap->height());
}
