#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <queue>
#include <QPainter>
#include <math.h>
#include <QMouseEvent>
#include <QDebug>
#include <QProcess>
#include <QCursor>


namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);

    MainWindow(QString chttrans,QString punc,QString fullwidth,QString vk,QString remind);


    ~MainWindow();

private slots:
    void on_pushButton_clicked();

    void on_checkBox_fullwidth_stateChanged(int arg1);

    void on_recover_clicked();

    void on_saveBtn_clicked();

    void on_checkBox_punc_stateChanged(int arg1);

    void on_checkBox_vk_stateChanged(int arg1);

    void on_checkBox_chttrans_stateChanged(int arg1);

    void on_checkBox_remind_stateChanged(int arg1);

private:
    Ui::MainWindow *ui;
    void init();
    void paintEvent(QPaintEvent *e);
    void mouseMoveEvent(QMouseEvent *event);
    void mousePressEvent(QMouseEvent *event);
    void mouseReleaseEvent(QMouseEvent *event);
    QString getUserName();
    void saveSettingToFile(QString result);
    QPoint mousePosition;
    bool isMousePressed;
    QPixmap *pixmap;
    QString fullwidth;
    QString punc;
    QString vk;
    QString chttrans;
    QString remind;
    QString user_config_filepath= "/.config/fcitx/setting_file";




};

#endif // MAINWINDOW_H
