#include "mainwindow.h"
#include <QApplication>
#include <QDesktopWidget>
#include <QTextCodec>
#include <QTranslator>
#include "server.h"

int main(int argc, char *argv[])
{
    QTextCodec *codec = QTextCodec::codecForName("UTF-8");
    QTextCodec::setCodecForLocale(codec);
    QTextCodec::setCodecForCStrings(codec);

    QApplication a(argc, argv);
    MainWindow w;
    QTranslator qtTranslator;
    qtTranslator.load( "/usr/share/fcitx/personal-center/personal_zh_cn.qm");
    a.installTranslator( &qtTranslator );

    Server refresh_data_server;
    if (!refresh_data_server.init("localeserver-count-speed"))
    {
        return 1;
    }
    QObject::connect(&refresh_data_server,SIGNAL(newMessage(const QString &)),&w,SLOT(serverdealMessage(const QString &)));
    QDesktopWidget *pDesk = QApplication::desktop();
    w.move((pDesk->width() - w.width()) / 2, (pDesk->height() - w.height()) / 2);
    w.show();

    return a.exec();
}
