#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QtNetwork/QNetworkCookieJar>
#include <QCloseEvent>

#include "syncuserdb.h"

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    QString validateUserInfo();
    void loadLoginCache();

public slots:
    void attachQtObject();

    void msgBox(QString title, QString info);
    void closeWindow();
    QString getFileContent(QString filePathName);

    void saveLoginSession(QString session);
    QString getLoginSession();
    void removeLoginSession();

    void saveLastUser(QString user);
    QString getLastUser();

    void saveUid(QString uid, QString uName);
    void removeUid();

    QString getPwd(QString user);
    void savePwd(QString user, QString pwd);
    void removePwd(QString user);

    void onLoadedAll();//页面加载完成的回调
    void setCumVal(long cum);//设置页面累计输入字数
    void setRecordSpeedVal(int speed);//设置页面输入速度最高记录
    void setCurSpeedVal(int speed);//设置页面当前输入速度
    void setTodayVal(long val);//设置页面今日输入字数

    long getCumVal();//获取缓存的（非页面获取）累计输入字数
    int getRecordSpeedVal();//获取缓存的（非页面获取）输入速度最高记录
    int getCurSpeedVal();//获取缓存的（非页面获取）当前输入速度
    long getTodayVal();//获取缓存的（非页面获取）今日输入字数
    void serverdealMessage(QString m_server_message);
    void init();
    void writefile(QString sFilePath,QString m_content);

    void syncUserDB(QString email);
    void syncTotalinputNum(QString email);
    void syncTodayTotalinputNum(QString email);
    QString  getLocalMac();
    QString md5_encode(QString m_in);
    void setMacmd5();
    void changefile(QString sFilePath,QString m_content,QString origin);
    void uploadtodayinputnum();


    QString getFcitxVersion();

private slots:
    void slot_loadStarted();
    void slot_loadFinished(bool ok);
    void slot_complete_sync(bool notError, int process);
    void replyFinished( QNetworkReply* reply);
    void TodayreplyFinished(QNetworkReply* reply);

protected:
    QString getCurrentLoginUser();
    QString getRegVal(QString path, QString key, QString default_val = NULL);
    void closeEvent(QCloseEvent *evt);

private:
    Ui::MainWindow *ui;
    QNetworkCookieJar *cookie;
    QString cacheFile;
    QString URL;
    QString email;

    long cumCache;
    int speedCache;
    int recordSpeedCache;
    long todayCache;

    SyncUserDB *su;

};

#endif // MAINWINDOW_H
