#ifndef SYNCUSERDB_H
#define SYNCUSERDB_H

#include <QObject>
#include <QMainWindow>
#include <QNetworkAccessManager>
#include <QNetworkReply>
#include <QFile>
/**
    #include "syncuserdb.h"
    //......
    SyncUserDB *su = new SyncUserDB();
    //同步完成之后处理的completeSync信号槽
    su->connect(su, SIGNAL(completeSync(bool, int)), this, SLOT(slot_complete_sync(bool, int)));
    if(su->init()) {//同步之前必须调用init检测并初始化用户及相关数据
        su->sync();
    }
    //......
    void MainWindow::slot_complete_sync(bool notError, int process) {
        qDebug()<<"Sync Complete!!"<<notError<<process;
    }
    //......
    //postHttp()不需要调用init
    QByteArray postData;
    postData.append("os=w");
    postData.append("&email=");
    postData.append("test@test.com");//
    postData.append("&user.cumulativeWord=");
    postData.append(QString::number(521, 10));//
    SyncUserDB *su = new SyncUserDB();
    su->connect(su, SIGNAL(completePost(bool, int, QString)), this, SLOT(slot_complete_post(bool, int, QString)));
    su->postHttp("http://localhost:8080/im_service/user_ex/syncWordCumu.action", postData);
    //......
    void MainWindow::slot_complete_post(bool notError, int process, QString replyInfo) {
        qDebug()<<"Sync Complete!!"<<notError<<process;
    }
 */
enum {
    PROCESS_STEP_INIT = 0,
    PROCESS_STEP_DOWNLOAD,
    PROCESS_STEP_DOWNLOAD_COMPLETE,
    PROCESS_STEP_UPLOAD,
    PROCESS_STEP_UPLOAD_COMPLETE,
    PROCESS_STEP_POST,
    PROCESS_STEP_POST_COMPLETE
};

class SyncUserDB : public QObject
{
    Q_OBJECT
public:
    explicit SyncUserDB(QObject *parent = 0);
    ~SyncUserDB();
    bool init();
    void sync();
    void postHttp(QString url, QByteArray &postData);
    void restartFcitx();

protected:
    int downlaod(QString url, QString tarPath);
    int upload(QString url, QString srcPath);
    int importFile(QString srcFile);
    int exportFile(QString tar);
    int merge(QString exportFile, QString serverFile, QString outputFile);
    void clearTempFile();
    bool copyFileTo(QString src, QString to, bool coverFileIfExist);

    QString getFileContent(QString filePathName);
    //QString getCurrentUserAPPData();
    QString getCurrentLoginUser();
    QString getRegVal(QString path, QString key, QString default_val = NULL);
    QString validateUserInfo();
    QString getFcitxVersion();

    bool checkDBFile(QString srcFile);
signals:
    void completeSync(bool notError, int curProcess);
    void completePost(bool notError, int curProcess, QString replyInfo);
    
private slots:
    void replyFinished(QNetworkReply* reply);

    void uploadError(QNetworkReply::NetworkError errorCode);
    void uploadProgress( qint64 bytesSent, qint64 bytesTotal );

    void downlaodReadyRead();
    void downloadError(QNetworkReply::NetworkError errorCode);
    void downloadProgress(qint64 bytesReceived, qint64 bytesTotal);

    void postError(QNetworkReply::NetworkError errorCode);

private:
    QNetworkAccessManager *manager;
    QNetworkReply *reply;
    int curProcess;//0start 1download 2import 3export 4upload 5complete
    char *upFileBuff;
    QFile *dwFile;

    QString baseURL;
    QString email;
    QString ver;
};

#endif // SYNCUSERDB_H
