/***************************************************************************
 *   Copyright (C) 2011~2012 by CSSlayer                                   *
 *   wengxt@gmail.com                                                      *
 *   Copyright (C) 2012~2013 by Yichao Yu                                  *
 *   yyc1992@gmail.com                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.              *
 ***************************************************************************/

#include <errno.h>
#include <iconv.h>
#include <unistd.h>
#include <ctype.h>
#include <iconv.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <netdb.h>
#include <unistd.h>


#include <libintl.h>
#include "pinyin-enhance-internal.h"
#include "pinyin-enhance-spell.h"
#include "pinyin-enhance-cfp.h"
#include "pinyin-enhance-sym.h"
#include "pinyin-enhance-py.h"
#include "../module/spell/spell-internal.h"
#include "../module/spell/spell-custom-dict.h"
#include "module/spell/fcitx-spell.h"		
#include <fcntl.h>
#include "fcitx-utils/uthash.h"
#include "sys/stat.h"
#include "sys/mman.h"
#include "fcitx-utils/utils.h"
#include "fcitx-config/xdg.h"


#define DICT_BIN_MAGIC "FSCD0000"
#define QUICKPHRASE_CODE_LEN    20
#define QUICKPHRASE_PHRASE_LEN  40
#define TIME_INTERVAL 60

extern time_t input_starttime;

typedef struct _Speed
{
	long s_starttime;
	long s_endtime;
	long s_inputnum;
} Speed;

Speed speed_calculate[TIME_INTERVAL] = { 0 };
int speed_start_pos = 0;


void array_recombinant(Speed m_speed[], int m_start_pos)
{
	int i;
	for (i = 0;i < TIME_INTERVAL;i++)
	{
		if (m_speed[m_start_pos].s_inputnum == 0)
		{
			for (int j = i;j < TIME_INTERVAL;j++)
			{
				m_speed[j].s_starttime = 0;
				m_speed[j].s_endtime = 0;
				m_speed[j].s_inputnum = 0;
				
			}
			break;
		}
		else
		{
			m_speed[i] = m_speed[m_start_pos];
		}
		m_start_pos++;
	}
}
int Get_First_Num(Speed m_speed[], long m_endtime)
{
	int i;
	int first_start_pos = 0;
	for (i = 0;i < TIME_INTERVAL;i++)
	{
		if ((m_endtime - m_speed[i].s_starttime) <= TIME_INTERVAL)
		{
			first_start_pos = i;
			break;
		}
	}
	return first_start_pos;
}

long calculate_speed(Speed m_speed[], int m_speed_Length)
{
	int i;
	long m_speed_total = 0;
	for (i = 0; i < TIME_INTERVAL; i++)
	{
		if (m_speed[i].s_inputnum == 0)
			break;
		m_speed_total += m_speed[i].s_inputnum;
	}
	return m_speed_total;

}
int Get_Array_Num(Speed m_speed[])
{
	int ArrayNum = 0;
	for (int i = 0; i < TIME_INTERVAL; i++)
	{
		if (m_speed[i].s_starttime == 0)
		{
			ArrayNum = i;
			break;
		}

	}
	return ArrayNum;
}

static const char *codes =   
"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";  
  
static const unsigned char map[256] = {  
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 253, 255,  
255, 253, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,  
255, 255, 255, 255, 255, 255, 255, 255, 253, 255, 255, 255,  
255, 255, 255, 255, 255, 255, 255,  62, 255, 255, 255,  63,  
 52,  53,  54,  55,  56,  57,  58,  59,  60,  61, 255, 255,  
255, 254, 255, 255, 255,   0,   1,   2,   3,   4,   5,   6,  
  7,   8,   9,  10,  11,  12,  13,  14,  15,  16,  17,  18,  
 19,  20,  21,  22,  23,  24,  25, 255, 255, 255, 255, 255,  
255,  26,  27,  28,  29,  30,  31,  32,  33,  34,  35,  36,  
 37,  38,  39,  40,  41,  42,  43,  44,  45,  46,  47,  48,  
 49,  50,  51, 255, 255, 255, 255, 255, 255, 255, 255, 255,  
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,  
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,  
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,  
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,  
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,  
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,  
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,  
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,  
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,  
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,  
255, 255, 255, 255 };  
  
int base64_encode(const unsigned char *in,  unsigned long len,   
                        unsigned char *out)  
{  
   unsigned long i, len2, leven;  
   unsigned char *p;  
   /* valid output size ? */  
   len2 = 4 * ((len + 2) / 3);  
   p = out;  
   leven = 3*(len / 3);  
   for (i = 0; i < leven; i += 3) {  
       *p++ = codes[in[0] >> 2];  
       *p++ = codes[((in[0] & 3) << 4) + (in[1] >> 4)];  
       *p++ = codes[((in[1] & 0xf) << 2) + (in[2] >> 6)];  
       *p++ = codes[in[2] & 0x3f];  
       in += 3;  
   }  
   /* Pad it if necessary...  */  
   if (i < len) {  
       unsigned a = in[0];  
       unsigned b = (i+1 < len) ? in[1] : 0;  
       unsigned c = 0;  
  
       *p++ = codes[a >> 2];  
       *p++ = codes[((a & 3) << 4) + (b >> 4)];  
       *p++ = (i+1 < len) ? codes[((b & 0xf) << 2) + (c >> 6)] : '=';  
       *p++ = '=';  
   }  
  
   /* append a NULL byte */  
   *p = '\0';  
  
   return p - out;  
}  
  
int base64_decode(const unsigned char *in, unsigned char *out)  
{  
    unsigned long t, x, y, z;  
    unsigned char c;  
    int g = 3;  
  
    for (x = y = z = t = 0; in[x]!=0;) {  
        c = map[in[x++]];  
        if (c == 255) return -1;  
        if (c == 253) continue;  
        if (c == 254) { c = 0; g--; }  
        t = (t<<6)|c;  
        if (++y == 4) {  
            out[z++] = (unsigned char)((t>>16)&255);  
            if (g > 1) out[z++] = (unsigned char)((t>>8)&255);  
            if (g > 2) out[z++] = (unsigned char)(t&255);  
            y = t = 0;  
        }  
    }  
    return z;  
}  
void cmd_shell_result(const char* command,char * result,int length)
{
    FILE *fpRead;
    fpRead = popen(command, "r");
    char buf[1024];
    memset(buf,'\0',sizeof(buf));
    while(fgets(buf,1024-1,fpRead)!=NULL)
    {
        strncpy(result,buf,length);
        result = buf;
    }
    if(fpRead!=NULL)
        pclose(fpRead);
    return ;
}
/**Get File Content*/
void ReadFileContent(char *m_filepath,char *m_resultcontent)
{
/*	char cmd[1024];
	snprintf(cmd,sizeof(cmd),"cat %s",m_filepath);
	printf("cmd is %s\n",cmd);
	char result_temp[1024];
	cmd_shell_result(cmd,result_temp,sizeof(result_temp));
	printf("result is %s\n",result_temp);
	strncpy(m_resultcontent,result_temp,sizeof(result_temp));
*/	

	char linebuffer[512];
	FILE *fp=fopen(m_filepath,"r+");
        if (fp == NULL)
        {
		strcpy(m_resultcontent,"0");
                return;
        }
        while(fgets(linebuffer,512,fp))
        {
		strcpy(m_resultcontent,linebuffer);
		if (m_resultcontent[strlen(m_resultcontent)-1] == '\n')
			m_resultcontent[strlen(m_resultcontent)-1] = '\0';
		break;

        }
	fclose(fp);
}
///////////////////////////////////////////////////////////
QuickPhraseState *globalEnhanceqpstate = NULL;
static UT_icd qp_icd = { sizeof(QUICK_PHRASE), NULL, NULL, NULL };

static void *PinyinEnhanceCreate(FcitxInstance *instance);
static void PinyinEnhanceDestroy(void *arg);
static void PinyinEnhanceReloadConfig(void *arg);
static void PinyinEnhanceAddCandidateWord(void *arg);
static void PinyinEnhanceResetHook(void *arg);
static boolean PinyinEnhancePostInput(void *arg, FcitxKeySym sym,
                                      unsigned int state,
                                      INPUT_RETURN_VALUE *retval);
static boolean PinyinEnhancePreInput(void *arg, FcitxKeySym sym,
                                     unsigned int state,
                                     INPUT_RETURN_VALUE *retval);

static char* PinyinEnhanceUserEnglishDicHook(void* arg,const char* in);

void loadEnglisgDict(void* arg);
void loadWebSiteDict(void* arg);
void loadEmailDict(void * arg);
void loadUserEmailDict(void* arg);
PinyinEnhance *globalpyenhance;
DECLARE_ADDFUNCTIONS(PinyinEnhance)

CONFIG_BINDING_BEGIN(PinyinEnhanceConfig)
CONFIG_BINDING_REGISTER("Pinyin Enhance", "ShortAsEnglish", short_as_english);
CONFIG_BINDING_REGISTER("Pinyin Enhance", "AllowReplaceFirst",
                        allow_replace_first);
CONFIG_BINDING_REGISTER("Pinyin Enhance", "DisableSpell", disable_spell);
CONFIG_BINDING_REGISTER("Pinyin Enhance", "DisableSym", disable_sym);
CONFIG_BINDING_REGISTER("Pinyin Enhance", "StrokeThresh", stroke_thresh);
CONFIG_BINDING_REGISTER("Pinyin Enhance", "StrokeLimit", stroke_limit);
CONFIG_BINDING_REGISTER("Pinyin Enhance", "MaximumHintLength", max_hint_length);
CONFIG_BINDING_REGISTER("Pinyin Enhance", "InputCharFromPhraseString",
                        char_from_phrase_str);
CONFIG_BINDING_REGISTER("Pinyin Enhance", "InputCharFromPhraseKey",
                        char_from_phrase_key);
CONFIG_BINDING_END()

CONFIG_DEFINE_LOAD_AND_SAVE(PinyinEnhance, PinyinEnhanceConfig,
                            "fcitx-pinyin-enhance")

FCITX_DEFINE_PLUGIN(fcitx_pinyin_enhance, module, FcitxModule) = {
    .Create = PinyinEnhanceCreate,
    .Destroy = PinyinEnhanceDestroy,
    .SetFD = NULL,
    .ProcessEvent = NULL,
    .ReloadConfig = PinyinEnhanceReloadConfig
};

DEFINE_GET_AND_INVOKE_FUNC(SunPinyin, GetFullPinyin, 0)

static int
check_im_type(PinyinEnhance *pyenhance)
{
    FcitxIM *im = FcitxInstanceGetCurrentIM(pyenhance->owner);
    if (!im)
        return PY_IM_INVALID;
    if (strcmp(im->uniqueName, "pinyin") == 0 ||
        strcmp(im->uniqueName, "pinyin-libpinyin") == 0 ||
        strcmp(im->uniqueName, "googlepinyin") == 0 ||
        strcmp(im->uniqueName, "shuangpin-libpinyin") == 0)
        return PY_IM_PINYIN;
    if (strcmp(im->uniqueName, "shuangpin") == 0)
        return PY_IM_SHUANGPIN;
    if (strcmp(im->uniqueName, "sunpinyin") == 0) {
        boolean sp = false;
        char *str;
        FCITX_DEF_MODULE_ARGS(args, "", &sp);
        str = FcitxSunPinyinInvokeGetFullPinyin(im->owner->owner, args);
        fcitx_utils_free(str);
        return sp ? PY_IM_SHUANGPIN : PY_IM_PINYIN;
    }
    return PY_IM_INVALID;
}

CONFIG_DESC_DEFINE(GetQuickPhraseConfigDesc, "fcitx-quickphrase.desc")

void SaveQuickPhraseConfig(QuickPhraseConfig* qpconfig)
{
    FcitxConfigFileDesc* configDesc = GetQuickPhraseConfigDesc();
    FILE *fp = FcitxXDGGetFileUserWithPrefix("conf", "fcitx-quickphrase.config",
                                             "w", NULL);
    FcitxConfigSaveConfigFileFp(fp, &qpconfig->gconfig, configDesc);
    if (fp)
        fclose(fp);
}
boolean LoadQuickPhraseConfig(QuickPhraseConfig *qpconfig)
{
    FcitxConfigFileDesc* configDesc = GetQuickPhraseConfigDesc();
    if (configDesc == NULL)
        return false;

    FILE *fp;
    fp = FcitxXDGGetFileUserWithPrefix("conf", "fcitx-quickphrase.config",
                                       "r", NULL);
    if (!fp) {
        if (errno == ENOENT) {
            SaveQuickPhraseConfig(qpconfig);
        }
    }


    return true;
}

void LoadQuickPhraseFromFile(QuickPhraseState* qpstate, FILE* fp)
{
    char *buf = NULL;
    size_t len = 0;
    char *buf1 = NULL;

    QUICK_PHRASE tempQuickPhrase;
    while (getline(&buf, &len, fp) != -1) {
        if (buf1)
            free(buf1);
        buf1 = fcitx_utils_trim(buf);
        char *p = buf1;

        while (*p && !isspace(*p))
            p ++;

        if (*p == '\0')
            continue;

        while (isspace(*p)) {
            *p = '\0';
            p ++;
        }

        size_t keylen = strlen(buf1);
        if (strlen(buf1) >= QUICKPHRASE_CODE_LEN)
            continue;

        size_t phraselen = strlen(p);
        if (strlen(p) >= QUICKPHRASE_PHRASE_LEN * UTF8_MAX_LENGTH)
            continue;

        if (!fcitx_utf8_check_string(p))
            continue;

        tempQuickPhrase.strCode = fcitx_memory_pool_alloc(qpstate->memPool, keylen + 1);
        tempQuickPhrase.strPhrase = fcitx_memory_pool_alloc(qpstate->memPool, phraselen + 1);

        strcpy(tempQuickPhrase.strCode, buf1);
        strcpy(tempQuickPhrase.strPhrase, p);

        utarray_push_back(qpstate->quickPhrases, &tempQuickPhrase);
    }

    if (buf)
        free(buf);
    if (buf1)
        free(buf1);
}

void LoadQuickPhrase(QuickPhraseState * qpstate)
{
    FILE *fp;

    qpstate->uQuickPhraseCount = 0;
    utarray_new(qpstate->quickPhrases, &qp_icd);

    fp =  FcitxXDGGetFileWithPrefix("data", "QuickPhrase.mb", "r", NULL);
    if (fp) {
        LoadQuickPhraseFromFile(qpstate, fp);
        fclose(fp);
    }

    FcitxStringHashSet* additionalFile = FcitxXDGGetFiles("data/quickphrase.d", NULL, ".mb");
    HASH_SORT(additionalFile, fcitx_utils_string_hash_set_compare);

    HASH_FOREACH(fileName, additionalFile, FcitxStringHashSet) {
        char* disableTest;
        asprintf(&disableTest, "%s.disable", fileName->name);
        FILE* ftest = FcitxXDGGetFileWithPrefix("data/quickphrase.d", disableTest, "r", NULL);
        free(disableTest);
        if (ftest) {
            fclose(ftest);
            continue;
        }

        FILE* f = FcitxXDGGetFileWithPrefix("data/quickphrase.d", fileName->name, "r", NULL);

        if (!f) {
            continue;
        }

        LoadQuickPhraseFromFile(qpstate, f);

        fclose(f);
    }

    fcitx_utils_free_string_hash_set(additionalFile);


    if (qpstate->quickPhrases) {
        utarray_sort(qpstate->quickPhrases, PhraseCmp);
    }
}

void *QuickPhraseCreate(FcitxInstance *instance)
{
    QuickPhraseState *qpstate = fcitx_utils_new(QuickPhraseState);
    qpstate->owner = instance;
    qpstate->enabled = false;
    qpstate->memPool = fcitx_memory_pool_create();

    LoadQuickPhrase(qpstate);
    return qpstate;
}


static void*
PinyinEnhanceCreate(FcitxInstance *instance)
{
    PinyinEnhance *pyenhance = fcitx_utils_new(PinyinEnhance);
    pyenhance->owner = instance;

    QuickPhraseState *qpstate = QuickPhraseCreate(instance);
    globalEnhanceqpstate = qpstate;

    if (!PinyinEnhanceLoadConfig(&pyenhance->config)) {
        free(pyenhance);
        return NULL;
    }

    PinyinEnhanceSymInit(pyenhance);

    FcitxIMEventHook event_hook = {
        .arg = pyenhance,
        .func = PinyinEnhanceAddCandidateWord,
    };
    FcitxInstanceRegisterUpdateCandidateWordHook(instance, event_hook);
    event_hook.func = PinyinEnhanceResetHook;
    FcitxInstanceRegisterResetInputHook(instance, event_hook);

    FcitxKeyFilterHook key_hook = {
        .arg = pyenhance,
        .func = PinyinEnhancePostInput
    };
    FcitxInstanceRegisterPostInputFilter(pyenhance->owner, key_hook);
    key_hook.func = PinyinEnhancePreInput;
    FcitxInstanceRegisterPreInputFilter(pyenhance->owner, key_hook);
    //添加提交输入内容HOOK实现用户英文词库
    FcitxStringFilterHook user_en_hook = {
             .arg = pyenhance,
             .func = PinyinEnhanceUserEnglishDicHook
    };
    FcitxInstanceRegisterCommitFilter(pyenhance->owner,user_en_hook);
   //加载英文词库
    loadEnglisgDict((void*)pyenhance);
   //加载网址库  
    loadWebSiteDict((void*)pyenhance);
    //加载系统邮箱库
    loadEmailDict((void*)pyenhance);
    //加载用户邮箱
    loadUserEmailDict((void*)pyenhance);
    FcitxPinyinEnhanceAddFunctions(instance);
    return pyenhance;
}

static boolean
PinyinEnhancePreInput(void *arg, FcitxKeySym sym, unsigned int state,
                      INPUT_RETURN_VALUE *retval)
{
    PinyinEnhance *pyenhance = (PinyinEnhance*)arg;
    if (!check_im_type(pyenhance))
        return false;
    if (PinyinEnhanceCharFromPhrasePre(pyenhance, sym, state, retval))
        return true;
    return false;
}

static boolean
PinyinEnhancePostInput(void *arg, FcitxKeySym sym, unsigned int state,
                       INPUT_RETURN_VALUE *retval)
{
    PinyinEnhance *pyenhance = (PinyinEnhance*)arg;
    if (!check_im_type(pyenhance))
        return false;
    if (PinyinEnhanceCharFromPhrasePost(pyenhance, sym, state, retval))
        return true;
    return false;
}

static void
PinyinEnhanceAddCandidateWord(void *arg)
{
    PinyinEnhance *pyenhance = (PinyinEnhance*)arg;
    int im_type;
    /* reset cfp */
    PinyinEnhanceCharFromPhraseCandidate(pyenhance);
    /* check whether the current im is pinyin */
    if (!(im_type = check_im_type(pyenhance)))
        return;
    /* pysym and stroke */
    /* struct timespec start, end; */
    /* int t; */
    /* clock_gettime(CLOCK_PROCESS_CPUTIME_ID, &start); */
    if (PinyinEnhanceSymCandWords(pyenhance, im_type))
        return;
    /* clock_gettime(CLOCK_PROCESS_CPUTIME_ID, &end); */
    /* t = ((end.tv_sec - start.tv_sec) * 1000000000) */
    /*     + end.tv_nsec - start.tv_nsec; */
    /* printf("%s, %d\n", __func__, t); */
    if (!pyenhance->config.disable_spell)
        PinyinEnhanceSpellHint(pyenhance, im_type);
    return;
}

static void
PinyinEnhanceDestroy(void *arg)
{
    PinyinEnhance *pyenhance = (PinyinEnhance*)arg;
    PinyinEnhanceSymDestroy(pyenhance);
    fcitx_memory_pool_destroy(globalEnhanceqpstate->memPool);
    py_enhance_buff_free(&pyenhance->stroke_tree.keys);
    py_enhance_buff_free(&pyenhance->stroke_tree.words);
}

static void
PinyinEnhanceReloadConfig(void *arg)
{
    PinyinEnhance *pyenhance = (PinyinEnhance*)arg;
    PinyinEnhanceLoadConfig(&pyenhance->config);
    PinyinEnhanceSymReloadDict(pyenhance);
}

char*
PinyinEnhanceGetSelected(PinyinEnhance *pyenhance)
{
    FcitxInputState *input;
    char *string;
    input = FcitxInstanceGetInputState(pyenhance->owner);
    string = FcitxUIMessagesToCString(FcitxInputStateGetPreedit(input));
    /**
     * Haven't found a way to handle the case when the word before the current
     * one is not handled by im-engine (e.g. a invalid pinyin in sunpinyin).
     * (a possible solution is to deal with different im-engine separately).
     * Not very important though....
     **/
    *fcitx_utils_get_ascii_part(string) = '\0';
    return string;
}

static void
PinyinEnhanceResetHook(void *arg)
{
    PinyinEnhance *pyenhance = (PinyinEnhance*)arg;
    PinyinEnhanceCharFromPhraseReset(pyenhance);
}



/*user english dict*/

typedef struct {
     char *word;
     int count;
     UT_hash_handle hh;
}UserEngDict;
typedef struct {
     char ip[512];
     int port;
     boolean ret;
}ipAndPort;
boolean userEngDictLoaded = false;
boolean webSiteDictLoaded = false;
boolean emailDictLoaded = false;
boolean UserEmailDictLoaded = false;
UserEngDict* userEngDict;

void AddToSpellCustomDict(void* arg,const char* word)
{
    PinyinEnhance *pyenhance = (PinyinEnhance*)arg;
    FcitxAddon* addon = FcitxAddonsGetAddonByName(FcitxInstanceGetAddons(pyenhance->owner),FCITX_SPELL_NAME);
    FcitxSpell *spell = (FcitxSpell *)addon->addonInstance;
    SpellCustomDict *dict = (SpellCustomDict*)spell->custom_dict;
      size_t total_len;
     int i;
     for(i=0;i<dict->words_count;i++)//查重
     {
         if(strcmp(dict->map+dict->words[i],word)==0)
             return ;
     } 
       void *tempMap = NULL ,*tempWords = NULL;
       int tempWordsCounts = dict->words_count;
       total_len = dict->words[dict->words_count-1]+strlen(dict->map+dict->words[dict->words_count-1])+strlen(word)+1+1;
       tempMap = realloc(dict->map,total_len);
      // printf("words[dict->words_count]:%d\n",dict->words[dict->words_count-2]);
       //printf("%s\n",dict->map+dict->words[dict->words_count-2]);
       //printf("words[dict->words_count]:%d\n",dict->words[dict->words_count-1]);
      // printf("%s\n",dict->map+dict->words[dict->words_count-1]);
      // printf("total_len:%d\n",total_len);
       tempWordsCounts++;
       tempWords = realloc(dict->words,tempWordsCounts*sizeof(uint32_t));
       if(tempMap&&tempWords)
       {
         dict->map = (char*)tempMap;
         memcpy(dict->map+dict->words[dict->words_count-1]+strlen(dict->map+dict->words[dict->words_count-1])+1,word,strlen(word)+1);
         dict->words_count = tempWordsCounts;
         dict->words = (int*)tempWords;
         dict->words[dict->words_count-1]  = dict->words[dict->words_count-2]+strlen(dict->map+dict->words[dict->words_count-2])+1;
       }

     // struct stat stat_buf;
     // fd = SpellCustomGetSysDictFile(spell,"en");
     // if(fd == -1)
     //    return NULL;
     // if(fstat(fd,&stat_buf) == -1)
     //     return NULL;
     // total_len = stat_buf.st_size - strlen(DICT_BIN_MAGIC);
      //total_len = dict->words[dict->words_count-1]+strlen(dict->map+dict->words[dict->words_count-1])+strlen(word)+1;
      //dict->map = realloc(dict->map,total_len);
     // memcpy(dict->map+dict->words[dict->words_count-1]+strlen(dict->map+dict->words[dict->words_count-1])+1,word,strlen(word)+1);
    // //dict->map[total_len-1]="\0";
     // dict->words_count++;
     // dict->words = realloc(dict->words,dict->words_count*sizeof(uint32_t));
     // dict->words[dict->words_count-1]  = dict->words[dict->words_count-2]+strlen(dict->map+dict->words[dict->words_count-2])+1;
     // printf("%s\n",dict->map+dict->words[dict->words_count-1]);
}

void loadEnglisgDict(void* arg)
{
   if(userEngDictLoaded)
       return;
   globalpyenhance = (PinyinEnhance *)arg;
   userEngDictLoaded = true;
   char* tempfile;
   int fd;
   struct stat statBuff;
   char* p;
   char* fileEnd;
   FcitxXDGGetFileUserWithPrefix("pinyin","","w",NULL);
   FcitxXDGGetFileUserWithPrefix("pinyin","userEngDict",NULL,&tempfile);
   //printf("%s\n",tempfile);
   fd = open(tempfile,O_RDWR|O_APPEND|O_CREAT,0644);
   if(fd == -1)
   {
     printf("%s open error\n",tempfile);
     return;
   }
   if(fstat(fd,&statBuff)==-1)
      return;
   p = mmap(NULL,statBuff.st_size + 1,PROT_READ, MAP_PRIVATE, fd, 0);
   fileEnd = statBuff.st_size + p;
   close(fd);
   while(p<fileEnd)
   {
      char tempBuff[1024];
      memset(tempBuff,0,1024);
      char* start;
      start = p;
      p += strcspn(p , "\n");
      strncpy(tempBuff , start ,p - start);
      AddToSpellCustomDict(arg,tempBuff);
      p++;
   } 

}

void addToUserEnglishDict(char* word)
{  
   char* tempfile;
   int fd;
   FcitxXDGGetFileUserWithPrefix("pinyin","","w",NULL);
   FcitxXDGGetFileUserWithPrefix("pinyin","userEngDict",NULL,&tempfile);
   //printf("%s\n",tempfile);
   fd = open(tempfile,O_RDWR|O_APPEND|O_CREAT,0644);
   if(fd == -1)
      printf("%s open error\n",tempfile);
   write(fd,word,strlen(word));
   write(fd,"\n",strlen("\n"));
   close(fd);
}

void reloadDict()
{
     PinyinEnhance *pyenhance = globalpyenhance;
     FcitxAddon* addon = FcitxAddonsGetAddonByName(FcitxInstanceGetAddons(pyenhance->owner),FCITX_SPELL_NAME);
     FcitxSpell *spell = (FcitxSpell *)addon->addonInstance;
   //  SpellCustomDict *dict = (SpellCustomDict*)spell->custom_dict;
     FcitxSpellCustomLoadDict(pyenhance->owner, "en");
      userEngDictLoaded = false;
      webSiteDictLoaded = false;
      emailDictLoaded = false;
      UserEmailDictLoaded = false;
      //加载英文词库
    loadEnglisgDict((void*)pyenhance);
   //加载网址库  
    loadWebSiteDict((void*)pyenhance);
   //加载系统邮箱
    loadEmailDict((void*)pyenhance);
    //加载用户邮箱
    loadUserEmailDict((void*)pyenhance);
}
 
 
void clearUserEnglishDict()
{
    char* tempfile;
    int fd;
    FcitxXDGGetFileUserWithPrefix("pinyin","","w",NULL);
    FcitxXDGGetFileUserWithPrefix("pinyin","userEngDict",NULL,&tempfile);
    //printf("%s\n",tempfile);
    fd = open(tempfile,O_RDWR);
    if(fd == -1)
       printf("%s open error\n",tempfile);
    if(truncate(tempfile,0) == -1)
       printf("%s clear error\n",tempfile);
    close(fd);
    reloadDict();
}

//void AddToSpellCustomDict(void* arg,const char* word)
//{
//    PinyinEnhance *pyenhance = (PinyinEnhance*)arg;
//    FcitxAddon* addon = FcitxAddonsGetAddonByName(FcitxInstanceGetAddons(pyenhance->owner),FCITX_SPELL_NAME);
//    FcitxSpell *spell = (FcitxSpell *)addon->addonInstance;
//    SpellCustomDict *dict = (SpellCustomDict*)spell->custom_dict;
//      size_t total_len;
//     // struct stat stat_buf;
//     // fd = SpellCustomGetSysDictFile(spell,"en");
//     // if(fd == -1)
//     //    return NULL;
//     // if(fstat(fd,&stat_buf) == -1)
//     //     return NULL;
//     // total_len = stat_buf.st_size - strlen(DICT_BIN_MAGIC);
//      total_len = dict->words[dict->words_count-1]+strlen(dict->map+dict->words[dict->words_count-1])+strlen(word)+1;
//      dict->map = realloc(dict->map,total_len);
//      memcpy(dict->map+dict->words[dict->words_count-1]+strlen(dict->map+dict->words[dict->words_count-1])+1,word,strlen(word)+1);
//     //dict->map[total_len-1]="\0";
//      dict->words_count++;
//      dict->words = realloc(dict->words,dict->words_count*sizeof(uint32_t));
//     dict->words[dict->words_count-1]  = dict->words[dict->words_count-2]+strlen(dict->map+dict->words[dict->words_count-2])+1;
//      printf("%s\n",dict->map+dict->words[dict->words_count-1]);
//}

UserEngDict* UserEngDictLookUp(const char *newWord)
{
   UserEngDict* DictEntry = NULL;
   HASH_FIND_STR(userEngDict,newWord,DictEntry);
   return DictEntry;
}

UserEngDict* AddUserEngDict(const char *newWord)
{
   UserEngDict* DictEntry = fcitx_utils_malloc0(sizeof(UserEngDict));
   DictEntry->word = strdup(newWord);
   DictEntry->count = 1;
   HASH_ADD_KEYPTR(hh,userEngDict,DictEntry->word,strlen(DictEntry->word),DictEntry);
   return DictEntry;
}


/*static int
SpellCustomGetSysDictFile(FcitxSpell *spell, const char *lang)
{
     FCITX_UNUSED(spell);
     int fd;
     char *path;
     char *fname;
     path = fcitx_utils_get_fcitx_path("pkgdatadir");
     fcitx_utils_alloc_cat_str(fname, path, "/spell/", lang, "_dict.fscd");
     free(path);
     fd = open(fname, O_RDONLY);
     free(fname);
     return fd;
}*/

void loadWebSiteDict(void* arg)
{
   if(webSiteDictLoaded)
       return;

   webSiteDictLoaded = true;
   globalpyenhance = (PinyinEnhance *)arg;
   char* tempfile;
   int fd;
   struct stat statBuff;
   char* p;
   char* fileEnd;
   FcitxXDGGetFileUserWithPrefix("pinyin","","w",NULL);
   FcitxXDGGetFileUserWithPrefix("pinyin","WebSiteDict",NULL,&tempfile);
   //printf("%s\n",tempfile);
   fd = open(tempfile,O_RDWR|O_APPEND|O_CREAT,0644);
   if(fd == -1)
   {
     printf("%s open error\n",tempfile);
     return;
   }
   if(fstat(fd,&statBuff)==-1)
      return;
   p = mmap(NULL,statBuff.st_size + 1,PROT_READ, MAP_PRIVATE, fd, 0);
   fileEnd = statBuff.st_size + p;
   close(fd);
   while(p<fileEnd)
   {
      char tempBuff[1024];
      memset(tempBuff,0,1024);
      char* start;
      start = p;
      p += strcspn(p , "\n");
      strncpy(tempBuff , start ,p - start);
      AddToSpellCustomDict(arg,tempBuff);
      p++;
   }
}


void addToWebSiteDict(char *word)
{
   char* tempfile;
   int fd;
   FcitxXDGGetFileUserWithPrefix("pinyin","","w",NULL);
   FcitxXDGGetFileUserWithPrefix("pinyin","WebSiteDict",NULL,&tempfile);
   //printf("%s\n",tempfile);
   fd = open(tempfile,O_RDWR|O_APPEND|O_CREAT,0644);
   if(fd == -1)
      printf("%s open error\n",tempfile);
   write(fd,word,strlen(word));
   write(fd,"\n",strlen("\n"));
   close(fd);
}

void clearWebSiteDict()
{
   char* tempfile;
   int fd;
   FcitxXDGGetFileUserWithPrefix("pinyin","","w",NULL);
   FcitxXDGGetFileUserWithPrefix("pinyin","WebSiteDict",NULL,&tempfile);
   //printf("%s\n",tempfile);
   fd = open(tempfile,O_RDWR);
   if(fd == -1)
      printf("%s open error\n",tempfile);
   if(truncate(tempfile,0) == -1)
      printf("%s clear error\n",tempfile);
   close(fd);
   //reloadDict();
}
//加载系统邮箱库
void loadEmailDict(void *arg)
{
  if(emailDictLoaded)
     return;
  emailDictLoaded = true;
  globalpyenhance = (PinyinEnhance *)arg;
  char* tempfile;
  int fd;
  struct stat statBuff;
  char* p;
  char* fileEnd;
  tempfile = fcitx_utils_get_fcitx_path_with_filename("pkgdatadir","py-enhance/emailDict");
  //printf("%s\n",tempfile);
  fd = open(tempfile,O_RDONLY);
  if(fd == -1)
  {
    printf("%s open error\n",tempfile);
    return;
  }
  if(fstat(fd,&statBuff)==-1)
    return;
  p = mmap(NULL,statBuff.st_size + 1,PROT_READ, MAP_PRIVATE, fd, 0);
  fileEnd = statBuff.st_size + p;
  close(fd);
  while(p<fileEnd)
  {
   char tempBuff[1024];
   memset(tempBuff,0,1024);
   char* start;
   start = p;
   p += strcspn(p , "\n");
   strncpy(tempBuff , start ,p - start);
   AddToSpellCustomDict(arg,tempBuff);
   p++;
  }
}
//加载用户邮箱库
void loadUserEmailDict(void* arg)
{
   if(UserEmailDictLoaded)
       return;

   UserEmailDictLoaded = true;
   globalpyenhance = (PinyinEnhance *)arg;
   char* tempfile;
   int fd;
   struct stat statBuff;
   char* p;
   char* fileEnd;
   FcitxXDGGetFileUserWithPrefix("pinyin","","w",NULL);
   FcitxXDGGetFileUserWithPrefix("pinyin","UserEmailDict",NULL,&tempfile);
   //printf("%s\n",tempfile);
   fd = open(tempfile,O_RDWR|O_APPEND|O_CREAT,0644);
   if(fd == -1)
   {
     printf("%s open error\n",tempfile);
     return;
   }
   if(fstat(fd,&statBuff)==-1)
      return;
   p = mmap(NULL,statBuff.st_size + 1,PROT_READ, MAP_PRIVATE, fd, 0);
   fileEnd = statBuff.st_size + p;
   close(fd);
   while(p<fileEnd)
   {
      char tempBuff[1024];
      memset(tempBuff,0,1024);
      char* start;
      start = p;
      p += strcspn(p , "\n");
      strncpy(tempBuff , start ,p - start);
      AddToSpellCustomDict(arg,tempBuff);
      p++;
   }
}
//添加邮箱到用户邮箱库
void addToUserEmailDict(char *word)
{
   char* tempfile;
   int fd;
   FcitxXDGGetFileUserWithPrefix("pinyin","","w",NULL);
   FcitxXDGGetFileUserWithPrefix("pinyin","UserEmailDict",NULL,&tempfile);
   //printf("%s\n",tempfile);
   fd = open(tempfile,O_RDWR|O_APPEND|O_CREAT,0644);
   if(fd == -1)
      printf("%s open error\n",tempfile);
   write(fd,word,strlen(word));
   write(fd,"\n",strlen("\n"));
   close(fd);
}
//清除用户邮箱库
void clearUserEmailDict()
{
   char* tempfile;
   int fd;
   FcitxXDGGetFileUserWithPrefix("pinyin","","w",NULL);
   FcitxXDGGetFileUserWithPrefix("pinyin","UserEmailDict",NULL,&tempfile);
   //printf("%s\n",tempfile);
   fd = open(tempfile,O_RDWR);
   if(fd == -1)
      printf("%s open error\n",tempfile);
   if(truncate(tempfile,0) == -1)
      printf("%s clear error\n",tempfile);
   close(fd);
   reloadDict();
}
//处理用户邮箱输入
void processUserEmail(void *arg, char *word)
{
   char tempstr[512] = {} ;
   char *strptr = NULL;
   int index;
   strcpy(tempstr , word);
   index = strcspn(tempstr , "@");
   strptr = tempstr;
   if(index>0)
   {
     strptr += index; 
   }
   addToUserEmailDict(strptr);
   AddToSpellCustomDict(arg,strptr);
}


int calculateNumberOfHZ(char *str)
{
     // utf_8 to gbk
  // printf("**1\n");
      char *tempstr = str;
      int n;
      //strcpy(tempstr,str);
   // printf("**2\n");   
      int len = strlen(tempstr)*2+1;
      char *outstr = (char*)malloc(len);
      memset(outstr,0,len);
   // printf("**3\n");
      char *in = tempstr;
      char *out = outstr;
      size_t inlen = strlen(tempstr);
      size_t outlen = len;
      iconv_t cd = iconv_open("gbk","utf-8");
   //  printf("**4\n");
     if((iconv_t)-1 == cd)
      {
     //    printf("%d\n",errno);
         printf("iconv error\n");
         free(outstr);
         return -1;
      }
 //    printf("**5\n");
      n = iconv(cd,&in,&inlen,&out,&outlen);
  //   printf("**6\n");
      iconv_close(cd);
      if(n<0)
      {
         printf("iconv error\n");
         free(outstr);
         return -1;      
      }
      
      //calculate
      n = 0;
      int i = 0;
      int strl = strlen(outstr);
       //printf("**7\n");
      for(;i < strl;++i)
      {
         if((!outstr[i]>=0 || i == strl -1))
         {
            short high = (short)(outstr[i] + 256);
            short low = (short)(outstr[i+1]+256);
            unsigned int code = high*256 + low;
            if(code>=0xB0A1 && code <= 0xF7FE|| code >= 0x8140 && code <= 0xA0FE ||code>=0xAA40 && code<=0xFEA0)
             n++;
            
            printf("code:%d\n",code);
         }
        i++;
      }
  // printf("**8\n");
   free(outstr);
   printf("number:%d\n",n);
   return n;
}
char * readIP()
{
    char ip[256] = {};
    char rip[256] = {};
    FILE *fp = FcitxXDGGetFileWithPrefix("personal-center","web_config","r",NULL);
    if(!fp)
        return NULL;

    fgets(ip, 256, fp);
    fclose(fp);
    if(strlen(ip)>0)
    {
          int c;
          c = strcspn(ip,":");
          if(c>0)
          {
             strncpy(rip,ip,c);
             return strdup(rip);
          }
          else
          {
             return NULL;
          }
    }
    else
        return NULL;
}

int readport()
{

    char port[256] = {};
    char rport[256] = {};
    FILE *fp = FcitxXDGGetFileWithPrefix("personal-center","web_config","r",NULL);
    if(!fp)
        return 0;

    fgets(port, 256, fp);
    fclose(fp);
    if(strlen(port)>0)
    {
          int c;
          c = strcspn(port,":");
          if(c>0)
          {
            strcpy(rport,port+c+1);
            int p = strtol(rport,NULL,0);
            return p;
          }
          else
          {
              return 0;
          }
    }
    else
    {
        return 0;
    }

}
ipAndPort readIPandPort()
{
    char filebuff[256] = {};
    ipAndPort ip_port = {{},0,false};
    FILE *fp = FcitxXDGGetFileWithPrefix("personal-center","web_config","r",NULL);
    if(!fp)
    {
        printf("open error:personal-center/web_config\n");
        return ip_port;
    }

    fgets(filebuff, 256, fp);
    fclose(filebuff);

        if(strlen(filebuff)>0)
        {
          int c;
          c = strcspn(filebuff,":");
          if(c>0)
          {
             strncpy(ip_port.ip,filebuff,c);
             ip_port.port = strtol(filebuff[c],NULL,0);
             if(ip_port.port > 0)
                ip_port.ret = true;
            return ip_port;
          }
          else
          {
             return ip_port; 
          } 
        }
    else
        return ip_port;
}
//send to http server
//#define IP "192.168.0.100"  //"172.16.50.80"
//#define PORT 8080
#define HOST "/im_service/user/syncWordCumu.action"
#define BUFSIZE 10240
#define TIMEOUT 1000 //socket读写超时时间//10s
int tcp_connect(char *host, int port)
{
    int sock, flags;
    struct sockaddr_in rsock;
    struct hostent * hostinfo;
    struct in_addr * addp;
    struct linger stLinger = { 1, 2 }; 
    
    memset ((char *)&rsock,0,sizeof(rsock));
    
    if ((hostinfo = gethostbyname(host)) == NULL)
    {
        return -1;
    }
    //步骤一:socket
    sock = socket(AF_INET, SOCK_STREAM, 0);
    if (sock == -1)
    {
        return -1;
    }
    //步骤二:填充
    addp = (struct in_addr *)*(hostinfo->h_addr_list);
    rsock.sin_addr = *addp;
    rsock.sin_family = AF_INET;
    rsock.sin_port = htons(port);
    
    int ret = 0, error = -1, slen = sizeof(int);
    struct timeval tm;
    fd_set set;
    
    unsigned long ul = 1;
  //  ioctl(sock, FIONBIO, &ul); //设置为非阻塞模式
          int flagss = fcntl(sock,F_GETFL,0);
        fcntl(sock,F_SETFL,flagss|O_NONBLOCK);
    //步骤三:connect，此时socket设置为非阻塞，connect调用后，无论连接是否建立立即返回-1，

    if (connect(sock, (struct sockaddr *)(&rsock), sizeof(rsock)) == -1)
    {
    //表示此时tcp三次握手仍旧进行，如果errno不是EINPROGRESS，则说明连接错误，程序结束
        if (errno != EINPROGRESS)
        {
            ret = 0;
        }
        else
        {
        
            tm.tv_sec  = 0;
            tm.tv_usec = 200000;
            FD_ZERO(&set);
            FD_SET(sock, &set);
            //监听写集合
            if (select(sock+1, NULL, &set, NULL, &tm) > 0)
            {
            //过调用 getsockopt(sockfd,SOL_SOCKET,SO_ERROR,&error,&len); 函数返回值来判断是否发生错误
            //rror返回0则表示连接成功！
                getsockopt(sock, SOL_SOCKET, SO_ERROR, &error, (socklen_t *)&slen);
                if (error == 0)
                {
                    ret = 1;
                }
                else
                {
                    ret = 0;
                }
            }
            else
            {
                ret = 0;
            }
        }
    }
    else
    {//客户端和服务器已经建立连接
        ret = 1;
    }
    
    ul = 0;
    //ioctl(sock, FIONBIO, &ul); //设置为阻塞模式
    //ret =1:表示正常建立连接
    if (!ret)
    {
        close(sock);
        return -1;
    }
    //linger :徘徊的意思。SO_LINGER:表示经历time_wait阶段，且时间是stLinger中第二个参数指定的值。
    flags = setsockopt(sock, SOL_SOCKET, SO_LINGER, &stLinger, sizeof(struct linger));
    if (flags == -1)
    {
        close(sock);
        return -1;
    }
    
    return sock;
}
static int postHttp(long userId, long cumulativeWord, char *sessionId) {
	int sock, cr;
	struct sockaddr_in address;
        
        char IP[256] = {};
        char *rip = readIP();
        int PORT = readport();
        if((!rip ==NULL)&&(PORT!=0))
        {
           strcpy(IP,rip);
           free(rip);
           printf("ip:%s\n",IP);
           printf("port:%d\n",PORT);
           printf("userid:%d\n",userId);
           printf("sessionid:%s\n",sessionId);
        }
        else
        {
           return 0;
        }

           
	struct hostent *host;
	if((host = gethostbyname(IP)) == NULL) {//转换为ip
		return 0;
	}
	//socket configuration
	sock = socket(AF_INET, SOCK_STREAM, 0);
	int timeout = TIMEOUT;//ms
	if(-1 == setsockopt(sock, SOL_SOCKET, SO_RCVTIMEO, (char*)&timeout, sizeof(int))) {
		//printf("timeout set failure!!");
	}
	address.sin_family = AF_INET;
	address.sin_port = htons(PORT);
	address.sin_addr = *((struct in_addr*)host->h_addr);

	char httpStr[BUFSIZE], formData[BUFSIZE / 2];
	memset(httpStr, 0, BUFSIZE);
	//构建表单数据
	memset(formData, 0, BUFSIZE / 2);

	strcat(formData, "user.userId=");
	char tmp[64];
	memset(tmp, 0, 64);
	sprintf(tmp, "%ld", userId);
	strcat(formData, tmp);//用户id!!!!!!!!!!!!
	strcat(formData, "&user.cumulativeWord=");
	memset(tmp, 0, 64);
	sprintf(tmp, "%ld", cumulativeWord);
	strcat(formData, tmp);//累计字数!!!!!!!!!!!!

	char lenStr[128];
	sprintf(lenStr, "%ld", strlen(formData));

	printf("FormData:%s\n", formData);
	printf("FormData Size:%s\n", lenStr);

	//构建http协议文档
	strcat(httpStr, "POST ");
	strcat(httpStr, HOST);
	strcat(httpStr, " HTTP/1.1\r\n");
	strcat(httpStr, "Host: ");
	strcat(httpStr, IP);
	strcat(httpStr, "\r\n");
	strcat(httpStr, "Accept: text/html;*/*\r\n");
	strcat(httpStr, "Connection: Close\r\n");
	strcat(httpStr, "Cache-Control: no-cache\r\n");
	strcat(httpStr, "Cookie: JSESSIONID=");
	strcat(httpStr, sessionId);//session id 字符串!!!!!!!!!!!!
	strcat(httpStr, "; path=/\r\n");
	strcat(httpStr, "Content-Type: application/x-www-form-urlencoded\r\n");
	strcat(httpStr, "Content-Length: ");
	strcat(httpStr, lenStr);
	strcat(httpStr, "\n\n");
	strcat(httpStr, formData);
	printf("httpStr: \n%s\n", httpStr);
	//socket send
	char buff[64];
	char str[BUFSIZE];
	int cnt;
        //int flags = fcntl(sock,F_GETFL,0);
        //fcntl(sock,F_SETFL,flags|O_NONBLOCK);
	//cr = connect(sock, (struct sockaddr *)&address, sizeof(address));
        sock = tcp_connect(IP,PORT);
        printf("connect\n");
	if(cr == -1) {    
		return 0;
	}
	//发送
	write(sock, httpStr, strlen(httpStr));
                printf("write\n");
	int flag = 0;
	//读取返回内容
//	while((cnt = read(sock, buff, 1))) {
//		//只获取内容，不要http协议头
//		if(flag == 1 && strcmp(buff, "}") == 0) {
//			flag = 2;
//			break;
//		}
//		if(strcmp(buff, "{") == 0) {
//			flag = 1;
//			continue;
//		}
//		if(flag == 1) {
//			strcat(str, buff);
//		}
//	}
	close(sock);
	printf("return:%s\n", str);
	//split(str, ";", dest, num);//拆分字符串
	//str如果是空字符串，说明请求验证没有通过，一般是sessionId已经不存在了，也就可以判定为没登录，
	//如果返回有内容，应该是个已经去掉了开始和结束的大括号的json格式的字符串， "userId":1,"cumulativeWord":200 等等
	//只要str有内容就算执行成功了
	return 1;
}

char *GetIniKeyString(char *title,char *key,char *filename)  
{ 
       printf("lalalalalallala   file name is %s\n",filename);	
    FILE *fp;  
    int  flag = 0;  
    char sTitle[32], *wTmp;  
    static char sLine[1024];  
  
    sprintf(sTitle, "[%s]", title);  
    if(NULL == (fp = fopen(filename, "r"))) {  
        perror("fopen");  
        return NULL;  
    }  
  
    while (NULL != fgets(sLine, 1024, fp)) {  
        // 这是注释行  
        if (0 == strncmp("//", sLine, 2)) continue;  
        if ('#' == sLine[0])              continue;  
  
        wTmp = strchr(sLine, '=');  
        if ((NULL != wTmp) && (1 == flag)) {  
            if (0 == strncmp(key, sLine, wTmp-sLine)) { // 长度依文件读取的为准  
                sLine[strlen(sLine) - 1] = '\0';  
                fclose(fp);  
                return strdup(wTmp + 1);  
            }  
        } else {  
            if (0 == strncmp(sTitle, sLine, strlen(sLine) - 1)) { // 长度依文件读取的为准  
                flag = 1; // 找到标题位置  
            }  
        }  
    }  
    fclose(fp);  
    return NULL;  
} 
void sendHZcountToServer(int num)
{
   char *path;
   char *configFileName = "fcitx-uc.cache";
   //char *userId, sessionId;
   FcitxXDGGetFileUserWithPrefix("",configFileName,NULL,&path);
   //userId = GetIniKeyString("user","uid",path);
   //sessionId = GetIniKeyString("user","sess",path);

   char *sUserId = GetIniKeyString("user","uid",path);
   char *sessionId = GetIniKeyString("user","sess",path);

   if(sUserId&&sessionId)
    {
      long iUserid = strtol(sUserId,NULL,0);
///      postHttp(iUserid, num, sessionId);
      free(sUserId);
      free(sessionId);
    }
      
  // printf("userid:%s\n",sUserId);
  // printf("sessionid:%s\n",sessionId);
   //printf("path:%s\n",path);
}
void saveHZCountToFile(int num,char *user)
{
   char filename[128] = {};
   struct stat statBuff;
   char* tempfile;
   int i;
   int fd;
   char tempstr[128] = {};
   char count[128] = {};
   if(user == NULL){
        strcpy(filename,"inputHZcountTotal");
    }
    else{
        strcpy(filename,"inputHZcountTotal-");
        strcat(filename,user);
    }
   FcitxXDGGetFileUserWithPrefix("pinyin","","w",NULL);
   FcitxXDGGetFileUserWithPrefix("pinyin",filename,NULL,&tempfile);
   
   fd = open(tempfile,O_RDWR|O_CREAT,0644);
   if(fd == -1)
      printf("%s open error\n",tempfile);
   if(fstat(fd,&statBuff)==-1)
     return;
  // if(statBuff.st_size==0)
  //   return;
   //printf("statBuff.st_size:%d\n",statBuff.st_size);
   read(fd,tempstr,statBuff.st_size+1);
   close(fd);
   
   i = strtol(tempstr,NULL,0);
   printf("HZcount:%d\n",i);
   int numtoServer = i+num;
   sprintf(count,"%d",i+num);  

   fd = open(tempfile,O_RDWR);
   if(fd == -1)
      printf("%s open error\n",tempfile);
   if(truncate(tempfile,0) == -1)
      printf("%s clear error\n",tempfile);
    write(fd,count,strlen(count));
   close(fd);
//   sendHZcountToServer(numtoServer);//send to server
}

struct tm* getCurrentDate()
{
  time_t sec;
  struct tm *n;
  sec = time(NULL);
  n = localtime(&sec);
//  printf("%dyear%dmouth%dday",n->tm_year+1900,n->tm_mon+1,n->tm_mday);
   return n;
}

void saveHZCountToFileByDay(int num,char *user)
{
    char filename[128] = {};
    char filebuff[31][256] = {};
    char* tempfile;
    int fd;
    struct stat statBuff;
    struct tm *n;
    char timebuff[128] = {};
    if(user == NULL){
        strcpy(filename,"inputHZcount");
    }
    else{
        strcpy(filename,"inputHZcount-");
        strcat(filename,user);
    }
   FcitxXDGGetFileUserWithPrefix("pinyin","","w",NULL);
   FcitxXDGGetFileUserWithPrefix("pinyin",filename,NULL,&tempfile);
   fd = open(tempfile,O_RDWR|O_CREAT,0644);
   if(fd == -1)
      printf("%s open error\n",tempfile);
   if(fstat(fd,&statBuff)==-1)
     return;
   printf("st_size:%d\n",statBuff.st_size);
   close(fd);


   FILE *fp = fopen(tempfile,"r");
   if(fp == NULL)
    return;
   int line = 0;
   while(fgets(filebuff+line,256,fp)!=NULL)
   {
     printf("%d:%s",line,filebuff+line);
     line++;
   }
   fclose(fp);
    int i = 0;
    n = getCurrentDate();
    sprintf(timebuff,"%dyear%dmonth%dday:",n->tm_year+1900,n->tm_mon+1,n->tm_mday); 
    boolean newday = true;
    for(;i<line;i++)
    {
      if(strstr(filebuff[i],timebuff))
      {
          newday = false;
          int c = strcspn(filebuff[i],":");
          char oldnum[128] = {};
          char newnum[128] = {};
          strcpy(oldnum,filebuff[i]+c+1);
          //oldnum[strlen(oldnum)] = 0;
          //oldnum[strlen(oldnum)-1] = '\0';
          printf("oldnum:%s\n",oldnum);
          sprintf(newnum,"%d\n",strtol(oldnum,NULL,0)+num);
          printf("newnum:%s\n",newnum);
          memset(filebuff[i]+c+1,0,100);
          strcpy(filebuff[i]+c+1,newnum);
//          printf("@@%s\n",filebuff[i]);
      }
    }
    if(newday == true)
    {
      char newdaynum[128] = {};
      sprintf(newdaynum,"%d\n",num);
      strcpy(filebuff[line],timebuff);
      strcat(filebuff[line],newdaynum);
      printf("filebuff[line]:%s",filebuff[line+1]);
      line++;
    }
    int f = (line>30)?1:0;
    char tofilebuff[256*31] = {};
    for(;f<line;f++)
    {
      strcat(tofilebuff,filebuff[f]);
    }
   printf("%s",tofilebuff);
   fd = open(tempfile,O_RDWR);
   if(fd == -1)
      printf("%s open error\n",tempfile);
   if(truncate(tempfile,0) == -1)
      printf("%s clear error\n",tempfile);
      write(fd,tofilebuff,strlen(tofilebuff));
      close(fd);
}

int readTodaycount(char *user)
{
   char filename[128] = {};
   struct tm *n;
   char timebuff[128] = {};
   char filebuff[31][256] = {};
   char* tempfile;
   if(user == NULL){
        strcpy(filename,"inputHZcount");
    }
    else{
        strcpy(filename,"inputHZcount-");
        strcat(filename,user);
    }
   FcitxXDGGetFileUserWithPrefix("pinyin","","w",NULL);
   FcitxXDGGetFileUserWithPrefix("pinyin",filename,NULL,&tempfile);
   FILE *fp = fopen(tempfile,"r");
   if(fp == NULL)
    return;
   int line = 0;
   while(fgets(filebuff+line,256,fp)!=NULL)
   {
     printf("%d:%s",line,filebuff+line);
     line++;
   }
       fclose(fp);
     int i = 0;
    n = getCurrentDate();
    sprintf(timebuff,"%dyear%dmonth%dday:",n->tm_year+1900,n->tm_mon+1,n->tm_mday); 
    printf("diaoshuangjun *********  timebuf is %s\n",timebuff);
    for(;i<line;i++)
    {
      if(strstr(filebuff[i],timebuff))
      {
          int c = strcspn(filebuff[i],":");
          char oldnum[128] = {};
          strcpy(oldnum,filebuff[i]+c+1);
          //oldnum[strlen(oldnum)] = 0;
          //oldnum[strlen(oldnum)-1] = '\0';
          int t;
          t = strtol(oldnum,NULL,0);
          return t;
      }
    }
    return 0;
}



int readTodayHZcount(char *user)
{
   char filename[128] = {};
   struct tm *n;
   char timebuff[128] = {};
   char filebuff[31][256] = {};
   char* tempfile;
   if(user == NULL){
        strcpy(filename,"inputHZcount");
    }
    else{
        strcpy(filename,"inputHZcount-");
        strcat(filename,user);
    }
   FcitxXDGGetFileUserWithPrefix("pinyin","","w",NULL);
   FcitxXDGGetFileUserWithPrefix("pinyin",filename,NULL,&tempfile);
   FILE *fp = fopen(tempfile,"r");
   if(fp == NULL)
    return;
   int line = 0;
   while(fgets(filebuff+line,256,fp)!=NULL)
   {
     printf("%d:%s",line,filebuff+line);
     line++;
   }
       fclose(fp);
     int i = 0;
    n = getCurrentDate();
    printf(timebuff,"%dyear%dmonth%dday:",n->tm_year+1900,n->tm_mon+1,n->tm_mday); 
    for(;i<line;i++)
    {
      if(strstr(filebuff[i],timebuff))
      {
          int c = strcspn(filebuff[i],":");
          char oldnum[128] = {};
          strcpy(oldnum,filebuff[i]+c+1);
          //oldnum[strlen(oldnum)] = 0;
          //oldnum[strlen(oldnum)-1] = '\0';
          int t;
          t = strtol(oldnum,NULL,0);
          return t;
      }
    }
    return 0;
}

/********dsj -0814********/

void SaveAndDealSpeed(long m_speed,char*m_speedrecord_filepath)
{
	
        char read_record_result[512];
        ReadFileContent(m_speedrecord_filepath,read_record_result);

        printf("m_speedrecord_filepath is :%d,%s,%s\n",m_speed,read_record_result,m_speedrecord_filepath);
        int current_speed = 0;
        if(strlen(read_record_result) > 0)
                current_speed = atoi(read_record_result);
        if ( current_speed <m_speed)
        {
                FILE * fp = NULL;
                fp = fopen( m_speedrecord_filepath ,"w+");
                if(fp != NULL)
                {
                        fprintf(fp,"%ld",m_speed);
                        fclose(fp);
                }
        }


}
void WriteContentToFile(char *m_content,char *m_filepath)
{
        FILE * fp = NULL;
        fp = fopen(m_filepath,"w+");
        if(fp != NULL)
        {
                fprintf(fp,"%s",m_content);
                fclose(fp);
        }

}

void GetSplitString(char *m_string,char *m_flag,char *m_result,int m_id)
{
	printf("################进入函数GetSplitString，其中分割字符串为：%s\n",m_string);
        char buf1[256];
        char buf3[256];

	if (m_id == 0)
	{
        	sscanf(m_string, "%[^:]:%[^:]:%[^:]",m_result,buf1,buf3);
	}
	else if (m_id == 1)
	{
        	sscanf(m_string, "%[^:]:%[^:]:%[^:]", buf1,m_result,buf3);
	}
	/*char*token=strtok(m_string,m_flag);
	int i =0;

	while(token!=NULL){

		printf("%s\t",token);
		if (i == m_id)
		{
			strcpy(m_result,token);
			break;
		}

		token=strtok(NULL,m_flag);
		i++;
	} */
}
void Record_Last_Input_Time(const char *m_write_record_date_filepath)
{
	char last_first_string[512];
	char last_minute_string[512];
	char minute_string[512];

	time_t m_locale_date = time(NULL);
	struct tm* m_date = localtime(&m_locale_date);

	char last_input_date[512];
	ReadFileContent(m_write_record_date_filepath,last_input_date);

	char get_date[512];
	memset(get_date,0,512);
	snprintf(get_date,sizeof(get_date),"%d-%02d-%02d %02d",m_date->tm_year+1900,m_date->tm_mon+1,m_date->tm_mday,m_date->tm_hour);

	char write_record_date[512];
	memset(write_record_date,0,512);
	snprintf(write_record_date,sizeof(write_record_date),"%s:%02d:%02d",get_date,m_date->tm_min,m_date->tm_sec);

	if (strcmp(last_input_date,"0")==0)
	{
		printf("第一次写文件并上传文件\n");
		WriteContentToFile(write_record_date,m_write_record_date_filepath);
		popen("/usr/share/fcitx/personal-center/bin/upload_userdata -f","r");
	}
	else
	{
		GetSplitString(last_input_date,":",last_first_string,0);
		printf("------------- 分割文件中的年月日小时字符串为：%s，当前时间的年月日小时为：%s\n",last_first_string,get_date);
		if (strcmp(last_first_string,get_date)==0)
		{
			memset(last_minute_string,0,sizeof(last_minute_string));
			GetSplitString(last_input_date,":",last_minute_string,1);
			snprintf(minute_string,sizeof(minute_string),"%02d",m_date->tm_min);

			printf("[[[[[[[[[[[[[上次输入时间的分钟为 : %s,这次输入时间的分钟为：%s]]]]]]]]]]]]]]]]]]]]",last_minute_string,minute_string);
			if (strcmp(last_minute_string,minute_string)==0)
			{
				printf("分钟相同，不写文件\n");
				return;
			}
			else
			{
				printf("-------分钟不相同,上次时间为：%d，这次分钟时间为：%d\n",atoi(last_minute_string),m_date->tm_min);
				if ((m_date->tm_min - atoi(last_minute_string)) > 30)
				{
					printf("分钟超过30分钟，写文件并上传文件\n");
					WriteContentToFile(write_record_date,m_write_record_date_filepath);
					popen("/usr/share/fcitx/personal-center/bin/upload_userdata -f","r");
				}
			}
		}
		else
		{
			printf("写文件同时上传文件\n");
			WriteContentToFile(write_record_date,m_write_record_date_filepath);
			popen("/usr/share/fcitx/personal-center/bin/upload_userdata -f","r");
		}
	}



/*	string get_date = _IntToString(m_date->tm_year + 1900, 0) + "-" + _IntToString(m_date->tm_mon + 1, 1) + "-" + _IntToString(m_date->tm_mday, 1) + " " + _IntToString(m_date->tm_hour, 1);
	string write_record_date = get_date + ":" + _IntToString(m_date->tm_min, 1) + ":" + _IntToString(m_date->tm_sec, 1);

	string get_date_only = _IntToString(m_date->tm_year + 1900, 0) + "-" + _IntToString(m_date->tm_mon + 1, 1) + "-" + _IntToString(m_date->tm_mday, 1);
	std::wstring p_install_dir = install_weasel_dir() + L"\\personal\\init-server-data\\init_server_db.exe";

	if (old_input_date == "0")
	{
		_WriteToFile(write_record_date, m_write_record_date_filepath);
				
		WinExec(IME_WStringToString(p_install_dir).c_str(), SW_HIDE);
		//WinExec("Notepad.exe", SW_SHOW); 
	}
	else
	{
		vector <string> date_day_split_result = _split(old_input_date, ":");
		if (date_day_split_result[0] == get_date)
		{
			if (date_day_split_result[1] == _IntToString(m_date->tm_hour, 1))
			{
				return;
			}
			else
			{
				if ((m_date->tm_min - atoi(date_day_split_result[1].c_str())) > 30)
				{
					_WriteToFile(write_record_date, m_write_record_date_filepath);
				}
			}
		}
		else
		{
			_WriteToFile(write_record_date, m_write_record_date_filepath);
			vector <string> date_split_result = _split(date_day_split_result[0], " ");
			if (date_split_result[0] != get_date_only)
			{
				WinExec(IME_WStringToString(p_install_dir).c_str(), SW_HIDE);
			}
		}
	}*/
}



void HZstatistics(char *commit)
{
	char *path;
   	char *configFileName = "fcitx-uc.cache";
   //char *userId, sessionId;
	FcitxXDGGetFileUserWithPrefix("",configFileName,NULL,&path);
    	int hzNumber = calculateNumberOfHZ(commit);
//   char *uName = GetIniKeyString("User","EM",path);

	if((access("/usr/share/fcitx/personal-center/fcitx_user",F_OK))!=-1)
	{
		printf("file is exit !!!\n");   
    		char *uName_temp = GetIniKeyString("User","EM","/usr/share/fcitx/personal-center/fcitx_user");
    		char uName[512];
		memset(uName,0,512);
//	int ResultStatus = base64_decode("c3VuZmVpZmVpQHRlc3QuY29t",uName);
		int ResultStatus = base64_decode(uName_temp,uName);
   		printf("输入字数hzNumber为：%d,uName 为：%s\n",hzNumber,uName);

   		speed_calculate[speed_start_pos].s_starttime = input_starttime;
  
		time_t m_endtime = time(NULL);
 		speed_calculate[speed_start_pos].s_endtime = m_endtime;
 		speed_calculate[speed_start_pos].s_inputnum = hzNumber;
//	DWORD m_endtime = GetTickCount();
		long m_input_use_time = m_endtime - input_starttime;

		int re_start_pos = Get_First_Num(speed_calculate, m_endtime);
		array_recombinant(speed_calculate, re_start_pos);

	//speed_calculate[]
		long input_speed = calculate_speed (speed_calculate,TIME_INTERVAL);
		speed_start_pos = Get_Array_Num(speed_calculate);
		printf("speed_star_pos is %d\n",speed_start_pos);
		printf("*************************** 速度为：%ld\n",input_speed);

    		if(uName)
    		{
      			saveHZCountToFile(hzNumber,uName);
      			saveHZCountToFileByDay(hzNumber,uName);
//      free(uName);
    		}
    		else
    		{
       			saveHZCountToFile(hzNumber,NULL);
       			saveHZCountToFileByDay(hzNumber,NULL);
    		}
/****dsj add****/
	
		char speedfilename[512];
		memset(speedfilename,0,512);
		char *totalfilename;
		char *speedrecordfilename;

		char total_result[512];
		memset(total_result,0,512);
		char speedrecord_result[512];
		memset(speedrecord_result,0,512);

		char tempfile[512];
		memset(tempfile,0,512);
		snprintf(tempfile,sizeof(tempfile),"inputHZcountTotal-%s",uName);
   //	FcitxXDGGetFileUserWithPrefix("pinyin","","w",NULL);
		FcitxXDGGetFileUserWithPrefix("pinyin",tempfile,NULL,&totalfilename);

		int current_input_number = readTodaycount(uName);
		printf("\n今日输入字数为:%d\n",current_input_number);

		char current_inputnumber_string[512];
		memset(current_inputnumber_string,0,512);
		snprintf(current_inputnumber_string,sizeof(current_inputnumber_string),"%d",current_input_number);
	
		char *todayinputfilename;
		memset(tempfile,0,512);
		snprintf(tempfile,sizeof(tempfile),"inputHZcoutToday-%s",uName);
		FcitxXDGGetFileUserWithPrefix("pinyin",tempfile,NULL,&todayinputfilename);
		WriteContentToFile(current_inputnumber_string,todayinputfilename);

		char total_number_char [512];
		memset(total_number_char,0,512);
		ReadFileContent(totalfilename,total_result);

		memset(tempfile,0,512);
		snprintf(tempfile,sizeof(tempfile),"inputHZcountspeedrecord-%s",uName);
		FcitxXDGGetFileUserWithPrefix("pinyin",tempfile,NULL,&speedrecordfilename);

		SaveAndDealSpeed(input_speed,speedrecordfilename);
	
		ReadFileContent(speedrecordfilename,speedrecord_result);

		memset(tempfile,0,512);
		snprintf(tempfile,sizeof(tempfile),"activetime-%s",uName);
		char *active_timepath;
		FcitxXDGGetFileUserWithPrefix("pinyin",tempfile,NULL,&active_timepath);
	
		Record_Last_Input_Time(active_timepath);

/*	if (uName)
	{
		free(uName);
	}*/	
//	int total_input_number = ReadFileContent(totalfilename,)
		printf("##$$ 今日输入字数为:%d,累计字数为:%s,输入速度为:%ld, 最高输入速度为:%s\n",current_input_number,total_result,input_speed,speedrecord_result);
		char SendMessageToPersonal[1024];
		memset(SendMessageToPersonal,0,1024);
		snprintf(SendMessageToPersonal,sizeof(SendMessageToPersonal),"/usr/share/fcitx/personal-center/personal-client %d,%s,%ld,%s",current_input_number,total_result,input_speed,speedrecord_result);
		printf("运行向个人中心的发送命令为:%s",SendMessageToPersonal);
		system(SendMessageToPersonal);
	
	}
}
static char* PinyinEnhanceUserEnglishDicHook(void* arg,const char* in)
{
    PinyinEnhance *pyenhance = (PinyinEnhance*)arg;
    FcitxInputState *input;
    char *RawString;
    int i;
    FcitxAddon* addon = FcitxAddonsGetAddonByName(FcitxInstanceGetAddons(pyenhance->owner),FCITX_SPELL_NAME);
    FcitxSpell *spell = (FcitxSpell *)addon->addonInstance;
    SpellCustomDict *dict = (SpellCustomDict*)spell->custom_dict;
    input = FcitxInstanceGetInputState(pyenhance->owner);
    RawString = FcitxInputStateGetRawInputBuffer(input);
    //printf("RawString:%s\n",RawString);
    //printf("commitString:%s\n",in);
    //printf("strlen:%d\n",fcitx_utf8_strlen(in));
    //printf("get_ascII_partn:%d\n",fcitx_utils_get_ascii_partn(in,fcitx_utf8_strlen(in)));
    HZstatistics(in);
    if(strcmp(in,RawString) == 0)
    {
      for(i=0;i<dict->words_count;i++)
      {
         if(strcmp(dict->map+dict->words[i],RawString)==0)
             return NULL;
      }
      UserEngDict* DictEntry = UserEngDictLookUp(RawString);
      if(DictEntry == NULL)
      { 
        AddUserEngDict(RawString);
      }
      else
      {
        DictEntry->count++;
        if(DictEntry->count >= 2)
        { 
           if(strchr(DictEntry->word, 0x40)&&strstr(DictEntry->word,".com"))
           {
             processUserEmail(arg ,DictEntry->word);
           }
           else if(strncmp("www.",DictEntry->word,4)==0)
           {  
            addToWebSiteDict(DictEntry->word);
            AddToSpellCustomDict(arg,DictEntry->word); //add to cache and user dict  
           }
           else
           {
            addToUserEnglishDict(DictEntry->word);
            AddToSpellCustomDict(arg,DictEntry->word); //add to cache and user dict
           }
        }
      }
    }
   //printf("funtion out2\n");
   return NULL;
}




#include "fcitx-pinyin-enhance-addfunctions.h"
