#! /bin/python env
# -*- coding: utf-8 -*-
import urllib
import urllib2
from bs4 import BeautifulSoup as bs
import os
import time
from selenium import webdriver
import codecs
import json

dicts_filename = 'dicts.txt'

def read_words_from_web():
    url = 'http://xh.5156edu.com/pinyi.html'
    html = urllib2.urlopen(url).read()
    soup = bs(html, 'lxml')

    anchors = soup.find_all('a', attrs={'class':'fontbox'})
    dicts = {}    
    total = 0
    for anchor in anchors:
        link = anchor['href']
        pinyin = anchor.text.strip()
        href = 'http://xh.5156edu.com/%s' % link 
        while True:
            try:
                html2 = urllib2.urlopen(href, timeout=10).read()
                break
            except Exception, e:
                print 'retry with %s:%s' % (pinyin, href)

        #有些不被认识的汉字，在下一句中被忽略，返回空了
        html2 = html2.decode('gb2312','ignore')
        soup2 = bs(html2, 'lxml')
    
        anchors2 = soup2.find_all('a', attrs={'class':'fontbox'})
    

        valid = 0
        for anchor2 in anchors2:
            yinbiao = anchor2.parent.parent.find_all('td')[0].find_all('p')[0].text
            if yinbiao == u'未分类': #存在未分类的情况，就是找不到声调，音标就和拼音没两样了
                yinbiao = pinyin
            if len(anchor2.contents)==2:
                valid += 1
                word = anchor2.contents[0]
                if dicts.has_key(word):
                    dicts[word][yinbiao]=pinyin
                else:
                    dicts[word]={yinbiao:pinyin}
                print '%s:%s,%s' % (word,yinbiao, pinyin)
            else:
                #汉字不被认识，在decode的时候被ignore了
                pass
        total += valid
        print 'open href: %s for pinyin: %s, found %d words, total=%d' % (href, pinyin, valid, total)
    print 'there are %d different words!' % len(dicts)
    return dicts

def save_dicts(dicts):
    file = codecs.open(dicts_filename, "w+", 'utf-8')
    result = json.dumps(dicts, encoding='utf-8', ensure_ascii=False)
    #result = str(dicts)
    file.write(result)
    file.close()

def load_dicts():
    print 'open dict file'
    file = codecs.open(dicts_filename, "r", 'utf-8')
    input_text = file.read()
    dicts = json.loads(input_text)
    #dicts = eval(input_text)
    return dicts;

def gen_dicts():
    if os.path.exists(dicts_filename):
        dicts = load_dicts()
    else:
        dicts = read_words_from_web()
        save_dicts(dicts)
    return dicts
    
def gen_convert_inputs(dicts, size):
    keys = dicts.keys()
    no = 0
    inputs = {}
    while no*size < len(keys):
        max_limit = (no+1)*size -1 
        max_limit = len(keys)-1 if max_limit > len(keys) else max_limit
        inputs[no] = u'、'.join(keys[no*size:max_limit]) 
   #     print no, ':', inputs[no]
        no += 1
    return inputs


def chaizi(driver, inputs):
    elm_neirong = driver.find_element_by_id('zm_neirong')
    elm_jieguo = driver.find_element_by_id('zm_jieguo')
    elm_btn_chaizi = driver.find_element_by_id('zh_anniu_1')
    elm_btn_clear = driver.find_element_by_id('zh_anniu_3')
    elm_btn_clear.click()
    elm_neirong.send_keys(inputs)
    elm_btn_chaizi.click()
    result = ""
    num = len(inputs.split(u'、'))
    while len(result.split(u'、')) < num:
        time.sleep(1)
        result=elm_jieguo.get_attribute('value')
    return result

def match(matches, dicts, input, output):
    keys = set(dicts.keys())
    sources = input.split(u'、')
    dests = output.split(u'、')
    for x in range(0, len(sources)-1):
        word = sources[x]
        if len(dests[x]) == 2: #拆开了
            left = dests[x][0]
            right = dests[x][1]
            if left in keys and right in keys:
                matches[word] = [left, right]
                print '%s%s %s (%s) : %s, %s\n' % (dicts[left].values()[0], dicts[right].values()[0], word, dicts[word].keys()[0], left, right)  

def gen_matches(matches, dicts):
    print '%d words totally' % len(dicts)
    #print dicts
    inputs = gen_convert_inputs(dicts, 60)
    driver = webdriver.PhantomJS()
    driver.get('https://chaizi.51240.com')
    for key in inputs:
        print key
        input = inputs[key]
        output = chaizi(driver, input)
        #print 'key:', key
        #print 'input:', input
        #print 'output:', output
        match(matches, dicts, input, output)
    driver.close()
    print "generate matches over!"

if __name__ == "__main__":
    dicts = gen_dicts()
    matches = {}
    gen_matches(matches, dicts)
    print 'totally %d matches' % len(matches)
    file = codecs.open('chaizi.txt', 'w','utf-8')
    for word in matches:
        left = matches[word][0]
        right = matches[word][1]
        #file.write('%s%s %s (%s) : %s, %s\n' % (dicts[left].values()[0], dicts[right].values()[0], word, dicts[word].keys()[0], left, right))  
        file.write('%s%s %s(%s)\n' % (dicts[left].values()[0], dicts[right].values()[0], word, dicts[word].keys()[0])) 
    file.close()
