#include "phonogramDialog.h"
#include "ui_phonogramDialog.h"
#include <QDebug>

Dialog::Dialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::Dialog)
{
    ui->setupUi(this);

    QStandardItemModel *phonogram_model = new QStandardItemModel();
    //设置表格的各列的宽度值


    phonogram_model->setHorizontalHeaderItem(0, new QStandardItem(QObject::tr("one tone")));
    phonogram_model->setHorizontalHeaderItem(1, new QStandardItem(QObject::tr("two tones")));
    phonogram_model->setHorizontalHeaderItem(2, new QStandardItem(QObject::tr("three tones")));
    phonogram_model->setHorizontalHeaderItem(3, new QStandardItem(QObject::tr("four tones")));

    //利用setModel()方法将数据模型与QTableView绑定
    ui->phonogramtableView->setModel(phonogram_model);

    //设置列宽不可变动，即不能通过鼠标拖动增加列宽
    ui->phonogramtableView->horizontalHeader()->setResizeMode(0, QHeaderView::Fixed);
    ui->phonogramtableView->horizontalHeader()->setResizeMode(1, QHeaderView::Fixed);
    ui->phonogramtableView->horizontalHeader()->setResizeMode(2, QHeaderView::Fixed);
    ui->phonogramtableView->horizontalHeader()->setResizeMode(3, QHeaderView::Fixed);


    //默认显示行头，如果你觉得不美观的话，我们可以将隐藏
    ui->phonogramtableView->verticalHeader()->hide();

    //设置表格的单元为只读属性，即不能编辑
    ui->phonogramtableView->setEditTriggers(QAbstractItemView::NoEditTriggers);

    ui->phonogramtableView->setColumnWidth(0,60);
    ui->phonogramtableView->setColumnWidth(1,60);
    ui->phonogramtableView->setColumnWidth(2,60);
    ui->phonogramtableView->setColumnWidth(3,60);

     new QStandardItem();
    QString test;
    qDebug()<< test << endl;

    phonogram_model->setItem(0, 0, new QStandardItem(u8"ā"));
    phonogram_model->setItem(0, 1, new QStandardItem(u8"á"));
    phonogram_model->setItem(0, 2, new QStandardItem(u8"ǎ"));
    phonogram_model->setItem(0, 3, new QStandardItem(u8"à"));

    phonogram_model->setItem(1, 0, new QStandardItem(u8"ē"));
    phonogram_model->setItem(1, 1, new QStandardItem(u8"é"));
    phonogram_model->setItem(1, 2, new QStandardItem(u8"ě"));
    phonogram_model->setItem(1, 3, new QStandardItem(u8"è"));

    phonogram_model->setItem(2, 0, new QStandardItem(u8"ū"));
    phonogram_model->setItem(2, 1, new QStandardItem(u8"ú"));
    phonogram_model->setItem(2, 2, new QStandardItem(u8"ǔ"));
    phonogram_model->setItem(2, 3, new QStandardItem(u8"ú"));


    phonogram_model->setItem(3, 0, new QStandardItem(u8"ō"));
    phonogram_model->setItem(3, 1, new QStandardItem(u8"ó"));
    phonogram_model->setItem(3, 2, new QStandardItem(u8"ǒ"));
    phonogram_model->setItem(3, 3, new QStandardItem(u8"ò"));

    phonogram_model->setItem(4, 0, new QStandardItem(u8"ī"));
    phonogram_model->setItem(4, 1, new QStandardItem(u8"í"));
    phonogram_model->setItem(4, 2, new QStandardItem(u8"ǐ"));
    phonogram_model->setItem(4, 3, new QStandardItem(u8"ì"));

    phonogram_model->setItem(5, 0, new QStandardItem(u8"ǖ"));
    phonogram_model->setItem(5, 1, new QStandardItem(u8"ǘ"));
    phonogram_model->setItem(5, 2, new QStandardItem(u8"ǚ"));
    phonogram_model->setItem(5, 3, new QStandardItem(u8"ǜ"));


    for(int i = 0 ; i < 6 ; i ++  )
    {
        phonogram_model->item(i, 0)->setTextAlignment(Qt::AlignCenter);
        phonogram_model->item(i, 1)->setTextAlignment(Qt::AlignCenter);
        phonogram_model->item(i, 2)->setTextAlignment(Qt::AlignCenter);
        phonogram_model->item(i, 3)->setTextAlignment(Qt::AlignCenter);
    }

}

Dialog::~Dialog()
{
    delete ui;
}


void Dialog::on_addphonogramPushButton_clicked()
{
    int row= ui->phonogramtableView->currentIndex().row();
    int cloumn= ui->phonogramtableView->currentIndex().column();
    QAbstractItemModel *model = ui->phonogramtableView->model ();
    QModelIndex index = model->index(row,cloumn);//选中行第一列的内容
    QVariant data = model->data(index);
    QString phonogramSelectValue = data.toString();
    qDebug()<<" phonogramSelectValue is " << phonogramSelectValue;

     emit sendPhonogramData(phonogramSelectValue);
}

void Dialog::on_cancelPushButton_clicked()
{
    this->close();

}
