#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <string.h>
#include <stdlib.h>
#include <pthread.h>
#include <locale.h>

#define _(STRING) gettext(STRING)
/****upgrade function***/
GtkWidget *upgrade_dialog;
GtkWidget *upgrade_title_label,*upgrade_content_label,*update_layout;
GtkWidget *ignore_version_button,*now_install_button;
gboolean drag = FALSE;   // 只在左键按下时拖动窗体
int nX = 0;
int nY = 0;
char args[256];
GThread *g_thread;
int shownum = 0;
int RefreshFinishshow_flag = 0;
gint RefreshInstallItemId;
int check_install_success =0;

/*********/
gint RefreshCheckItemId;
int CheckShow_flag = 0;
int versionnum = 0;



typedef struct _InstallPKGInfo
{
	char software_name[512];
	char *sys_version[512];
	char *apt_version[512];
	int install_flag; //1 is need update;0 not need

}InstallPKGInfo;


InstallPKGInfo install_software_info[5] = {0};
char *fcitx_install_pkg[5] = {"fcitx,","fcitx-config,","cloudpinyin,","charpainting-data,","fcitx-cell-list,"};
char *fcitx_install_package[5] = {"fcitx","fcitx-config","cloudpinyin","charpainting-data","fcitx-cell-list"};
char *fcitx_install_package_name[5]={"输入法","输入法配置","输入法云拼音","输入法字符表情","输入法细胞词库相关插件"};

void cmd_shell_result(const char* command,char * result,int length)
{
    FILE *fpRead;
    fpRead = popen(command, "r");
    char buf[1024];
    memset(buf,'\0',sizeof(buf));
    while(fgets(buf,1024-1,fpRead)!=NULL)
    {
        strncpy(result,buf,length);
        result = buf;
    }
    if(fpRead!=NULL)
        pclose(fpRead);
    return ;
}

void change_font_style(GtkLabel *label,char *cssInfo)
{
	char *markup;
	const gchar *labelTitel = gtk_label_get_text(label);
	markup = g_markup_printf_escaped (cssInfo, labelTitel);
	gtk_label_set_markup (GTK_LABEL (label), markup);
	g_free (markup);
}

gint button_press_event(GtkWidget * widget,GdkEventButton * event, gpointer data)
{
        if (event->button == 1)       // 判断是否左键按下
        {
                 drag = TRUE;
                 nX = event->x;  // 取得鼠标相对于窗口的位置
                 nY = event->y;
        }
        return TRUE;
}

gint button_release_event(GtkWidget * widget, GdkEventButton * event,gpointer data)         // 鼠标抬起事件
{
        if (event->button == 1)
                 drag = FALSE;
        return TRUE;
}
gint motion_notify_event(GtkWidget * widget, GdkEventButton * event,gpointer data)         // 鼠标移动事件
{
        if (drag)
        {
                 int x, y;
                 GtkWidget *win = (GtkWidget *) data;
                 gtk_window_get_position((GtkWindow *) win, &x, &y);         // 取窗体绝对坐标
                 gtk_window_move((GtkWindow *) win, x + event->x - nX,
                             y + event->y - nY);// 移动窗体
        }
        return TRUE;
}

void delete_event( GtkWidget *widget,GdkEvent  *event,gpointer   data )  
{  
    /* 如果你的 "delete_event" 信号处理函数返回 FALSE，GTK 会发出 "destroy" 信号。 
     * 返回 TRUE，你不希望关闭窗口。 
     * 当你想弹出“你确定要退出吗?”对话框时它很有用。*/  
    g_print ("^^^^^^^^^^^^^^^^^^^^delete event occurred\n"); 

    gtk_main_quit();
   
} 

/****9 month 14****/

void Install_Software_Command(char *m_softwarename)
{
	char run_command[1024];
	memset(run_command,0,1024);

	if (strcmp(m_softwarename,"fcitx")==0)
	{
		strncpy(run_command,"install_fcitx_temp=`dpkg -l | grep fcitx| grep 4.2.8.3 |awk '{print $2}'`;install_fcitx=$install_fcitx_temp\" typewriting-feedback\" ; sudo /usr/share/fcitx/lexicon/bin/InstallSelectLexiconItem \"apt-get --reinstall --assume-yes --force-yes install $install_fcitx\"",sizeof(run_command));
	}
	else 
	{
/***
fcitx-config<->fcitx-configtool
cloudpinyin <-> fcitx-cloudpinyin
charpainting-data<-> cdos-typewriting-charpainting-data
fcitx-cell-list<->cdos-fcitx-cell-list
***/

		snprintf(run_command,sizeof(run_command),"fcitx_other_install=`dpkg -l | grep %s | awk '{print $2}'` ; sudo /usr/share/fcitx/lexicon/bin/InstallSelectLexiconItem \"apt-get --reinstall --assume-yes --force-yes install $fcitx_other_install\"",m_softwarename);
		
//		strncpy(run_command,"fcitx_config_install=`dpkg -l | grep fcitx-config | awk '{print $2}'` ; sudo /usr/share/fcitx/lexicon/bin/InstallSelectLexiconItem \"apt-get --reinstall --assume-yes --force-yes install $fcitx_config_install\"",sizeof(run_command));
	}
	printf("安装更新命令为:%s\n",run_command);
	system(run_command);
	

}


void Get_SysInstall_Version(char *m_softwarename,char *m_result)
{
	char sys_fcitx_version[512];
	memset(sys_fcitx_version,0,512);
	if (strcmp(m_softwarename,"fcitx")==0)
	{
		cmd_shell_result("dpkg -s fcitx | grep Version | cut -d ':' -f3",sys_fcitx_version,sizeof(sys_fcitx_version));
	}
	else
	{
		char get_sys_version_commamd[1024];
		memset(get_sys_version_commamd,0,1024);
		snprintf(get_sys_version_commamd,sizeof(get_sys_version_commamd),"softwarename=`dpkg -l | grep %s |awk '{print $2}'| head -n 1`;dpkg -s $softwarename | grep Version | cut -d ' ' -f2",m_softwarename);
		cmd_shell_result(get_sys_version_commamd,sys_fcitx_version,sizeof(sys_fcitx_version));
		
	}
    	sys_fcitx_version[strlen(sys_fcitx_version)-1]=0;
	strcpy(m_result,sys_fcitx_version);	

}
void Get_AptInstall_Version(char *m_softwarename,char *m_result)
{
    char apt_fcitx_version[512];
    memset(apt_fcitx_version,0,512);
    if (strcmp(m_softwarename,"fcitx")==0)
    {
	cmd_shell_result("apt-cache show fcitx | grep Version | head -n 1 | cut -d ':' -f3",apt_fcitx_version,sizeof(apt_fcitx_version));
    }
    else
    {
	char get_apt_version_command[1024];
	memset(get_apt_version_command,0,1024);
	snprintf(get_apt_version_command,sizeof(get_apt_version_command),"softwarename=`dpkg -l | grep %s |awk '{print $2}'| head -n 1`;apt-cache show $softwarename | grep Version | head -n 1 | cut -d ' ' -f2",m_softwarename);
	
	cmd_shell_result(get_apt_version_command,apt_fcitx_version,sizeof(apt_fcitx_version));	
    }
    apt_fcitx_version[strlen(apt_fcitx_version)-1]=0;
    strcpy(m_result,apt_fcitx_version);
}



int Check_Software_Version_IsorNotNew(char *m_softwarename)
{
    char apt_fcitx_version[512];
    char sys_fcitx_version[512];
    memset(apt_fcitx_version,0,512);
    memset(sys_fcitx_version,0,512);

    char software_realname[1024];


    if (strcmp(m_softwarename,"fcitx")==0)
    {
	cmd_shell_result("apt-cache show fcitx | grep Version | head -n 1 | cut -d ':' -f3",apt_fcitx_version,sizeof(apt_fcitx_version));
    	cmd_shell_result("dpkg -s fcitx | grep Version | cut -d ':' -f3",sys_fcitx_version,sizeof(sys_fcitx_version));
	
    }
    else
    {
	char get_sys_version_commamd[1024];
	char get_apt_version_command[1024];
	
	memset(get_sys_version_commamd,0,1024);
	memset(get_apt_version_command,0,1024);

	snprintf(get_sys_version_commamd,sizeof(get_sys_version_commamd),"softwarename=`dpkg -l | grep %s |awk '{print $2}'| head -n 1`;dpkg -s $softwarename | grep Version | cut -d ' ' -f2",m_softwarename);
	snprintf(get_apt_version_command,sizeof(get_apt_version_command),"softwarename=`dpkg -l | grep %s |awk '{print $2}'| head -n 1`;apt-cache show $softwarename | grep Version | head -n 1 | cut -d ' ' -f2",m_softwarename);
	
	cmd_shell_result(get_apt_version_command,apt_fcitx_version,sizeof(apt_fcitx_version));
    	cmd_shell_result(get_sys_version_commamd,sys_fcitx_version,sizeof(sys_fcitx_version));

	
	
    }
    apt_fcitx_version[strlen(apt_fcitx_version)-1]=0;
    sys_fcitx_version[strlen(sys_fcitx_version)-1]=0;
   
    if (strcmp(apt_fcitx_version,sys_fcitx_version)==0)
    {
	printf("system is new version\n");
	return 0;
    }
    else
    {
	printf("system is not new version\n");
        return 1;
    }

}

void Init_install_Info(char *m_needupdate_software)
{
	printf("^^^^^^^^^^^^^^^^^^^ need update list is %s\n",m_needupdate_software);
	for (int i =0 ; i< 5;i++)
	{
		strcpy(install_software_info[i].software_name,fcitx_install_package_name[i]);
		Get_SysInstall_Version(fcitx_install_package[i],install_software_info[i].sys_version);
		Get_AptInstall_Version(fcitx_install_package[i],install_software_info[i].apt_version);
		if (strstr(m_needupdate_software,fcitx_install_pkg[i])!=NULL)
		{
			install_software_info[i].install_flag = 1;
		}
		
	}
/****test***/
	for (int i =0; i<5;i++)
        {
		printf("################################################\n");
		printf("name is %s,sysversion is %s,apt version is %s, isornot update flag is %d\n",install_software_info[i].software_name,install_software_info[i].sys_version,install_software_info[i].apt_version,install_software_info[i].install_flag );
		printf("************************************************\n");
	}
	
}



/////////0914
int Check_Fcitx_VersionNew()
{
    char apt_fcitx_version[512];
    char sys_fcitx_version[512];
    memset(apt_fcitx_version,0,512);
    memset(sys_fcitx_version,0,512);

    cmd_shell_result("apt-cache show fcitx | grep Version | head -n 1 | cut -d ':' -f3",apt_fcitx_version,sizeof(apt_fcitx_version));
    cmd_shell_result("dpkg -s fcitx | grep Version | cut -d ':' -f3",sys_fcitx_version,sizeof(sys_fcitx_version));
    
    apt_fcitx_version[strlen(apt_fcitx_version)-1]=0;
    sys_fcitx_version[strlen(sys_fcitx_version)-1]=0;
    printf("system fcitx version is %s,apt source fcitx version is %s\n",sys_fcitx_version,apt_fcitx_version);
    
    if (strcmp(apt_fcitx_version,sys_fcitx_version)==0)
    {
	printf("system is new version\n");
	return 0;
    }
    else
    {
	printf("system is not new version\n");
        return 1;
    }

}

int check_package_install(char *package_name)
{
	char command_result[10];
    char command_string[1024];	
	
	memset(command_string,0,sizeof(command_string));
    snprintf(command_string,sizeof(command_string),"dpkg -l %s | tail -n 1 |awk '{print $1}'",package_name);
    printf("运行的命令为：%s\n",command_string);

    cmd_shell_result(command_string,command_result,10);
    command_result[strlen(command_result)-1]='\0';

	if (strcmp(command_result,"ii")==0)
	{
//已安装
		return 1;
	}
	else
	{
//未安装
		return 0;
	}

}



/************************0915*************************
int Check_Software_Version_IsorNotNew(char *m_softwarename)
{
    char apt_fcitx_version[512];
    char sys_fcitx_version[512];
    memset(apt_fcitx_version,0,512);
    memset(sys_fcitx_version,0,512);

    char software_realname[1024];


    if (strcmp(m_softwarename,"fcitx")==0)
    {
	cmd_shell_result("apt-cache show fcitx | grep Version | head -n 1 | cut -d ':' -f3",apt_fcitx_version,sizeof(apt_fcitx_version));
    	cmd_shell_result("dpkg -s fcitx | grep Version | cut -d ':' -f3",sys_fcitx_version,sizeof(sys_fcitx_version));
	
    }
    else
    {
	char get_sys_version_commamd[1024];
	char get_apt_version_command[1024];
	
	memset(get_sys_version_commamd,0,1024);
	memset(get_apt_version_command,0,1024);

	snprintf(get_sys_version_commamd,sizeof(get_sys_version_commamd),"softwarename=`dpkg -l | grep %s |awk '{print $2}'| head -n 1`;dpkg -s $softwarename | grep Version | cut -d ' ' -f2",m_softwarename);
	snprintf(get_apt_version_command,sizeof(get_apt_version_command),"softwarename=`dpkg -l | grep %s |awk '{print $2}'| head -n 1`;apt-cache show $softwarename | grep Version | head -n 1 | cut -d ' ' -f2",m_softwarename);
	
	cmd_shell_result(get_apt_version_command,apt_fcitx_version,sizeof(apt_fcitx_version));
    	cmd_shell_result(get_sys_version_commamd,sys_fcitx_version,sizeof(sys_fcitx_version));

	apt_fcitx_version[strlen(apt_fcitx_version)-1]=0;
    	sys_fcitx_version[strlen(sys_fcitx_version)-1]=0;
	
    }
   
    if (strcmp(apt_fcitx_version,sys_fcitx_version)==0)
    {
	printf("system is new version\n");
	return 0;
    }
    else
    {
	printf("system is not new version\n");
        return 1;
    }

}*/
///////////////////////////////////////////////
// 刷新后台进程


void InstallFcitxThread()
{
/*	char install_fcitx_command[1024];
	memset(install_fcitx_command,0,1024);
	
	char install_fcitx_item_value [1024] = "apt-get --reinstall --assume-yes --force-yes install fcitx";

	
	snprintf(install_fcitx_command,sizeof(install_fcitx_command),"sudo /usr/share/fcitx/lexicon/bin/InstallSelectLexiconItem \"%s\" ",install_fcitx_item_value);
	system(install_fcitx_command);

	if (Check_Fcitx_VersionNew() == 0)
	{
		printf("install successful!!!!!!\n");
		RefreshFinishshow_flag = 1;
	}
	else
	{
		printf("install failed !!!!!!!!\n");
		RefreshFinishshow_flag = 2;
	}
	
*/
	for(int i =0 ;i<5;i++)
	{
		if(install_software_info[i].install_flag == 1)
		{
			Install_Software_Command(fcitx_install_package[i]);
			if (Check_Software_Version_IsorNotNew(fcitx_install_package[i]) == 1)
			{
				check_install_success =1;
			}
		}
		
	}
	if (check_install_success== 0)
	{
		printf("install successful!!!!!!\n");
		RefreshFinishshow_flag = 1;
	}
	else
	{
		printf("install failed !!!!!!!!\n");
		RefreshFinishshow_flag = 2;
	}

}
void install_fcitx_thread()
{
	g_thread = g_thread_new("installFcitx",InstallFcitxThread,NULL);
/*	int temp;

	memset(&threadSoftwareUpdate, 0, sizeof(threadSoftwareUpdate));
	if ((temp = pthread_create(&threadSoftwareUpdate, NULL, (void *) InstallFcitxThread, NULL)) != 0)	//comment2

		printf("线程检查更新创建失败!\n");

	else

		printf("线程检查更新被创建\n");
*/
}


gboolean refresh_install_process()
{
	if (RefreshFinishshow_flag == 1)
	{
		printf("************* finish install process\n");
		gtk_label_set_text(GTK_LABEL(upgrade_content_label),_("Successful,current IM is new。"));
//		gtk_label_set_text(GTK_LABEL(upgrade_content_label),"安装成功，目前系统已为最新版本输入法。");
        	change_font_style((GtkLabel *)upgrade_content_label,"<span foreground=\"#007d65\" font_desc='10'>%s</span>");
   		RefreshFinishshow_flag = 0 ;
        	gtk_button_set_label(GTK_BUTTON(now_install_button),_("SURE"));
//		gtk_button_set_label(GTK_BUTTON(now_install_button),"  确定  ");
		gtk_widget_show(now_install_button);
		return 0;
         
        }
	else
	{
		if (RefreshFinishshow_flag == 2)
		{
			gtk_label_set_text(GTK_LABEL(upgrade_content_label),_("Update fail,please check net and apt-source？"));
//			gtk_label_set_text(GTK_LABEL(upgrade_content_label),"更新失败，请查看网络以及安装源是否正确？");
        		change_font_style((GtkLabel *)upgrade_content_label,"<span foreground=\"#ef4136\" font_desc='10'>%s</span>");
			RefreshFinishshow_flag = 0 ;
			gtk_button_set_label(GTK_BUTTON(now_install_button),_("SURE"));
//                        gtk_button_set_label(GTK_BUTTON(now_install_button),"  确定  ");
			gtk_widget_show(now_install_button);
			return 0;
		}
		else
		{
		
			printf("#######################show number is %d\n",shownum);
			if (shownum%3 == 0)
			{
//		    		gtk_label_set_text(GTK_LABEL(upgrade_content_label),"正在为您安装新版输入法，请稍后...");
               			gtk_label_set_text(GTK_LABEL(upgrade_content_label),_("Now installing IM，please wait..."));
			}
			else if (shownum%3 == 1)
			{
//		    		gtk_label_set_text(GTK_LABEL(upgrade_content_label),"正在为您安装新版输入法，请稍后......");
				gtk_label_set_text(GTK_LABEL(upgrade_content_label),_("Now installing IM，please wait......"));
			}
			else
			{
//		    		gtk_label_set_text(GTK_LABEL(upgrade_content_label),"正在为您安装新版输入法，请稍后.........");
				gtk_label_set_text(GTK_LABEL(upgrade_content_label),_("Now installing IM，please wait........."));
			}
        	        change_font_style((GtkLabel *)upgrade_content_label,"<span foreground=\"#130c0e\" font_desc='10'>%s</span>");
			shownum++ ;
		}
	}
	return 1;
}


void InstallFcitxProcessShow()
{
	RefreshInstallItemId = g_timeout_add (1*1000, refresh_install_process,NULL);
//	sleep(1);
	return;

}
void refresh_install_fcitx_show_thread()
{
	g_thread_new("install_fcitx_process",InstallFcitxProcessShow,NULL);
}
void install_sure_function(GtkWidget *widget,gpointer data)
{
	printf("标签的数值为：%s\n",gtk_button_get_label(GTK_BUTTON(widget)));
	//if (strcmp(gtk_button_get_label(GTK_BUTTON(widget))," 安装更新 ")==0)
        if (strcmp(gtk_button_get_label(GTK_BUTTON(widget)),_("update"))==0)
	{
		printf("安装更新啦啦啦\n");
//        	gtk_label_set_text(GTK_LABEL(upgrade_title_label),"输入法安装更新!");
		gtk_label_set_text(GTK_LABEL(upgrade_title_label),_("IM Updating!"));
        	change_font_style((GtkLabel *)upgrade_title_label,"<span foreground=\"#53261f\" font_desc='12'>%s</span>");
//        	gtk_label_set_text(GTK_LABEL(upgrade_content_label),"正在为您安装新版输入法，请稍后");
                gtk_label_set_text(GTK_LABEL(upgrade_content_label),_("Now installing IM，please wait"));
                change_font_style((GtkLabel *)upgrade_content_label,"<span foreground=\"#130c0e\" font_desc='10'>%s</span>");
		
		gtk_widget_hide(ignore_version_button);
		gtk_widget_hide(now_install_button);
		//刷新安装界面进程
		refresh_install_fcitx_show_thread();
		//刷新后台进程
		install_fcitx_thread();
	}
	else
	{
/*		printf("确定按钮按下,RefreshFinishshow_flag is %d\n",RefreshFinishshow_flag);
		if (RefreshFinishshow_flag ==0)
		{
			printf("正在安装   正在安装  正在安装  正在安装\n");
			g_source_remove(RefreshInstallItemId);
			g_thread_exit(g_thread);
		}*/
		gtk_main_quit();
	}	

}

/***检测输入法版本****/

gboolean refresh_check_process()
{ 
	 char buf[2048],buftotal[2048];

 printf("ssssss is %d\n",CheckShow_flag);	 
	 for (int i =0 ; i< 5;i++)
             {
	      strcpy(install_software_info[i].software_name,fcitx_install_package_name[i]);
	      Get_SysInstall_Version(fcitx_install_package[i],install_software_info[i].sys_version);
	      Get_AptInstall_Version(fcitx_install_package[i],install_software_info[i].apt_version);
	     }


	if (CheckShow_flag == 1) //no update
	{
		 if(strcmp(args,"timetoupdate")==0)
		{
			exit(0);
		}
						                      
		gtk_label_set_text(GTK_LABEL(upgrade_title_label),_("Current version is new!"));
        	change_font_style((GtkLabel *)upgrade_title_label,"<span foreground=\"#181d4b\" font_desc='12'>%s</span>");
		for(int j=0;j<5;j++)
	       { sprintf(buf,"%s当前版本:%s,最新版本：%s\n\n",install_software_info[j].software_name,install_software_info[j].sys_version,install_software_info[j].apt_version);
		if(j==0)  
    		    strcpy(buftotal,buf);
		else  
	      strcat(buftotal,buf);
	       }
		gtk_label_set_text(GTK_LABEL(upgrade_content_label),buftotal);

	//	gtk_label_set_text(GTK_LABEL(upgrade_content_label),_("IM and related package is new version."));
        	change_font_style((GtkLabel *)upgrade_content_label,"<span foreground=\"#130c0e\" font_desc='10'>%s</span>");
        	gtk_button_set_label(GTK_BUTTON(now_install_button),_("SURE"));
        	gtk_widget_show(now_install_button);
		return 0;
         
        }
	else if (CheckShow_flag == 2) //update
	{
		printf("222222222222222222222222\n");
		if(strcmp(args,"timetoupdate")==0)
		{
			printf("000000000000000000000\n");
			gtk_widget_show(upgrade_dialog);
		}
		gtk_label_set_text(GTK_LABEL(upgrade_title_label),_("New Version is availabel!"));
        	change_font_style((GtkLabel *)upgrade_title_label,"<span foreground=\"#181d4b\" font_desc='12'>%s</span>");
                for(int j=0;j<5;j++)
              { sprintf(buf,"%s当前版本:%s,最新版本：%s\n\n",install_software_info[j].software_name,install_software_info[j].sys_version,install_software_info[j].apt_version);
	        if(j==0)
	        strcpy(buftotal,buf);
		 else
               strcat(buftotal,buf);
             }
		gtk_label_set_text(GTK_LABEL(upgrade_content_label),buftotal);

        //	gtk_label_set_text(GTK_LABEL(upgrade_content_label),_("Found newer IM availabel,download and install immediately？"));
        	change_font_style((GtkLabel *)upgrade_content_label,"<span foreground=\"#130c0e\" font_desc='10'>%s</span>");
        	gtk_widget_show(ignore_version_button);
        	gtk_widget_show(now_install_button);
		return 0;
	}
	else //Checking
	{

		if (versionnum%2 == 0)
		{
               		gtk_label_set_text(GTK_LABEL(upgrade_content_label),_("Checking software version,please wait..."));
//               		gtk_label_set_text(GTK_LABEL(upgrade_content_label),_("正在检测输入法及相关软件版本，请稍后..."));
		}
		else 
		{
			gtk_label_set_text(GTK_LABEL(upgrade_content_label),_("Checking software version,please wait......"));
//			gtk_label_set_text(GTK_LABEL(upgrade_content_label),_("正在检测输入法及相关软件版本，请稍后......"));
		}
        	change_font_style((GtkLabel *)upgrade_content_label,"<span foreground=\"#130c0e\" font_desc='10'>%s</span>");
		versionnum++ ;

	}
	return 1;
}
void CheckVersionProcessShow()
{
	RefreshCheckItemId = g_timeout_add (1*1000, refresh_check_process,NULL);
	sleep(2);
	return;

}
void refresh_checkversion_show_thread()
{
	g_thread_new("check_version_show_process",CheckVersionProcessShow,NULL);
}


void CheckSoftVersionThread()
{
	char install_list[1024]="";
	int fcitx_install_flag = 0;
	int fcitx_update_flag = 0;
	for (int i =0; i<5;i++)
	{
		printf("value is %s\n",fcitx_install_package[i]);
		if (Check_Software_Version_IsorNotNew(fcitx_install_package[i])==1)
		{
			if (strcmp(fcitx_install_package[i],"fcitx") == 0)
			{
				fcitx_install_flag = 1;
			}
			strcat(install_list,fcitx_install_package[i]);
			strcat(install_list,",");
			fcitx_update_flag = 1;
			
		}

	}	
	printf("list is %s    flag is %d\n",install_list,fcitx_install_flag);
	
	if (fcitx_update_flag == 0)
	{
		CheckShow_flag = 1;
//			popen("/usr/share/fcitx/update/fcitx-upgrade noupdate","r");
	}
	else
	{
			CheckShow_flag =2;
			Init_install_Info(install_list);
/*			char open_update_command[1024];
			memset(open_update_command,0,sizeof(open_update_command));
			snprintf(open_update_command,sizeof(open_update_command),"/usr/share/fcitx/update/fcitx-upgrade %s",install_list);
			printf("open update command is %s\n",open_update_command);
			popen(open_update_command,"r");
*/		
	}
//	}
}

void check_version_thread()
{
	g_thread_new("checkVersion",CheckSoftVersionThread,NULL);
}




/*********************/

int main( int   argc, char *argv[] )  
{  

      
    gtk_init (&argc, &argv); 
    setlocale(LC_ALL,"");
    textdomain("fcitx"); 



  
//    Init_install_Info(argv[1]);
      
    /* 当窗口收到 "delete_event" 信号 (这个信号由窗口管理器发出，通常是“关闭” 
     * 选项或是标题栏上的关闭按钮发出的)，我们让它调用在前面定义的 delete_event() 函数。 
     * 传给回调函数的 data 参数值是 NULL，它会被回调函数忽略。*/  
//    g_signal_connect (G_OBJECT (window), "delete_event",G_CALLBACK (delete_event), NULL);  
      
    /* 在这里我们连接 "destroy" 事件到一个信号处理函数。   
     * 对这个窗口调用 gtk_widget_destroy() 函数或在 "delete_event" 回调函数中返回 FALSE 值 
     * 都会触发这个事件。*/  
//    g_signal_connect (G_OBJECT (window), "destroy",G_CALLBACK (destroy), NULL);  
      

    GtkWidget *icon_image = gtk_image_new_from_file("/usr/share/fcitx/update/weasel.ico");
    gtk_widget_show(icon_image);
      
    upgrade_dialog = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_window_set_resizable(GTK_WINDOW (upgrade_dialog), FALSE);
    gtk_window_set_deletable(GTK_WINDOW (upgrade_dialog), FALSE);
    gtk_window_set_icon_from_file(GTK_WINDOW(upgrade_dialog),"/usr/share/fcitx/imicon/pinyin.png",NULL);
    gtk_window_set_title(upgrade_dialog,(_("Upgrade")));
//    gtk_window_set_title(upgrade_dialog,_("updating"));
//    gtk_window_set_transient_for(upgrade_dialog,window);
//    gtk_window_set_modal(GTK_WINDOW(upgrade_dialog),TRUE);
    /* 设置窗口边框的宽度。*/  
    gtk_container_set_border_width (GTK_CONTAINER (upgrade_dialog), 5);  
//    gtk_window_set_decorated(GTK_WINDOW(upgrade_dialog), FALSE);
    gtk_window_set_position(GTK_WINDOW(upgrade_dialog),GTK_WIN_POS_CENTER);
    gtk_window_set_default_size(GTK_WINDOW(upgrade_dialog),600,250);
    gtk_widget_set_events(upgrade_dialog,
                   GDK_EXPOSURE_MASK | GDK_LEAVE_NOTIFY_MASK
                   | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK
                   | GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK);
/****添加内容****/
    update_layout = gtk_layout_new(NULL, NULL);
    gtk_widget_show(update_layout);
    gtk_widget_set_size_request(update_layout,600,250);
    gtk_container_add(GTK_CONTAINER(upgrade_dialog),update_layout);

//    upgrade_title_label = gtk_label_new("检测版本");
    upgrade_title_label = gtk_label_new(_("CheckVersion"));
//    change_font_style((GtkLabel *)upgrade_title_label,"<span foreground=\"#181d4b\" font_desc='15'>%s</span>");
    
    gtk_widget_show(upgrade_title_label);
    gtk_layout_put(GTK_LAYOUT(update_layout),upgrade_title_label, 90,10 );

//    upgrade_content_label = gtk_label_new("正在检测输入法及相关软件版本，请稍后");
    upgrade_content_label = gtk_label_new(_("Checking software version,please wait"));
//    change_font_style((GtkLabel *)upgrade_content_label,"<span foreground=\"#130c0e\" font_desc='10'>%s</span>");
    gtk_widget_show(upgrade_content_label);	
    gtk_layout_put(GTK_LAYOUT(update_layout),upgrade_content_label,90,50);
    
    
    gtk_layout_put(GTK_LAYOUT(update_layout),icon_image,15,10);

    printf("tttttttttt %s\n",argv[1]);
    char content_value[1024];
    memset(content_value,0,1024);

    char apt_version[512];
    memset(apt_version,0,512);
    cmd_shell_result("apt-cache show fcitx | grep Version | head -n 1 | cut -d ':' -f3",apt_version,sizeof(apt_version));
    apt_version[strlen(apt_version)-1]=0;
    
    char sys_version[512];
    memset(sys_version,0,512);
    cmd_shell_result("dpkg -s fcitx | grep Version | cut -d ':' -f3",sys_version,sizeof(sys_version));
    sys_version[strlen(sys_version)-1]=0;

    snprintf(content_value,sizeof(content_value),"%s 是目前可用的更新版本.",apt_version);

    ignore_version_button = gtk_button_new_with_label(_("Ignore"));
    now_install_button =  gtk_button_new_with_label(_("update"));
    
    gtk_layout_put(GTK_LAYOUT(update_layout),ignore_version_button,320,210);
    gtk_layout_put(GTK_LAYOUT(update_layout),now_install_button,470,210);

    g_signal_connect(GTK_WINDOW(upgrade_dialog), "button_press_event", G_CALLBACK (button_press_event), NULL);       // 加入事件回调
    g_signal_connect(GTK_WINDOW(upgrade_dialog), "motion_notify_event",G_CALLBACK( motion_notify_event), NULL);
    g_signal_connect(GTK_WINDOW(upgrade_dialog), "button_release_event", G_CALLBACK(button_release_event), NULL);

    g_signal_connect(GTK_BUTTON(ignore_version_button),"clicked",G_CALLBACK (delete_event),NULL);
    g_signal_connect(GTK_BUTTON(now_install_button),"clicked",G_CALLBACK (install_sure_function),NULL);
    if(argc<2)
    	gtk_widget_show(upgrade_dialog);
    

    refresh_checkversion_show_thread();
    check_version_thread();
    if(argc>1)
    {
          if(strcmp(argv[1], "timetoupdate") == 0)
          {
	        printf("8888888888888888888888888888\n");
		strcpy(args,argv[1]);
           }
    }
    gtk_main ();  
      
    return 0;  
}  
