
#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QDebug>
#include <QtNetwork/QNetworkInterface>
#include <QMessageBox>
#include <utmp.h>

int upload_num=0;
bool is_exit=false;
MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    QString fcitxversion=get_fcitx_version();
    QString email=ReadSettings();
    QString mac_addr;
    QString mac_addr_md5;
    mac_addr=getLocalMac();
    mac_addr_md5=md5_encode(mac_addr);

    QString num=getTodayinputNum(email);
    QDateTime time = QDateTime::currentDateTime();//获取系统现在的时间
    QString datetime = time.toString("yyyy-MM-dd");
    QString total_file_path = getHomeDir()+config_file_path;
    qDebug()<<"ssssssssssssssssssssssssssssssssss"<<total_file_path;
    systotalNum=new SyncTotalNumber(GetFileContent(web_config_file_path),email,total_file_path,mac_addr);
    UploadTodayinputNum(email,mac_addr,mac_addr_md5,datetime,num);
    QString current_time = GetActiveTime(email);
    UploadUserTotalInput(email);
    if (current_time != NULL && current_time != "")
    {
         UpdateNewData(email,mac_addr,mac_addr_md5,current_time,fcitxversion);
    }
    QString user_dict_path=get_userdic_file();
    UploadFileToServer(user_dict_path,email,fcitxversion);
}
MainWindow::MainWindow(QString email):
    ui(new Ui::MainWindow)
{
    user_email=email;
   QString fcitxversion=get_fcitx_version();
    Bake_User_dict(user_email);
    QString mac_addr;
    QString mac_addr_md5;
    mac_addr=getLocalMac();
    mac_addr_md5=md5_encode(mac_addr);
    QDateTime time = QDateTime::currentDateTime();//获取系统现在的时间
    QString current_time = time.toString("yyyy-MM-dd hh:mm:ss");
/****add Active Time check***/
    QString activetime_filepath = getHomeDir()+config_file_path+"activetime-"+email;
    writefile(activetime_filepath,current_time);
    QString systemlogid=GetSystemLogId();
     getOsName();
     getOsVersion();
     osNameVersion=OsName+"-"+OsVersion;
   // UploadSyslogid(user_email,"l",fcitxversion,systemlogid);
    UploadSyslogid(user_email,mac_addr,mac_addr_md5,systemlogid,current_time);

    UpdateNewData(user_email,mac_addr,mac_addr_md5,current_time,fcitxversion);
    QString user_dict_path=get_userdic_file();
   UploadFileToServer(user_dict_path,user_email,fcitxversion);
}
QString MainWindow::getTodayinputNum(QString email)
{
    QString file_path=getHomeDir()+"/.config/fcitx/pinyin/inputHZcoutToday-"+email;
    QFile f(file_path);
    if(!f.open(QIODevice::ReadOnly | QIODevice::Text))
    {
        return "0";
    }

    QTextStream txtInput(&f);
    QString lineStr;
    while(!txtInput.atEnd())
    {
        lineStr = txtInput.readLine();
        return lineStr;
    }

    f.close();

}
 void MainWindow::getOsName()
 {
     QProcess *process=new QProcess;
     QStringList params;
     QStringList result_list;

     params.append("-i");
     process->setProgram("lsb_release");
     process->setArguments(params);
     process->start();
     if(process->waitForFinished())
     {
         QString strTemp=QString::fromLocal8Bit(process->readAllStandardOutput());
         strTemp.trimmed();
         result_list=strTemp.split(":");
         QString name= result_list[1];
         name.chop(1);
         name.remove("\t");
         OsName=name;
     }
 }
 void MainWindow::getOsVersion()
 {
     QProcess *process=new QProcess;
     QStringList params;
     QStringList result_list;

     params.append("-r");
     process->setProgram("lsb_release");
     process->setArguments(params);
     process->start();
     if(process->waitForFinished())
     {
         QString strTemp=QString::fromLocal8Bit(process->readAllStandardOutput());
         strTemp.trimmed();
         result_list=strTemp.split(":");
         QString name= result_list[1];
         name.chop(1);
         name.remove("\t");
         OsVersion=name;
     }
 }
void MainWindow::UploadTodayinputNum(QString email, QString mac, QString mac_md5, QString datetime, QString num)
{
    QNetworkAccessManager *manager = new QNetworkAccessManager();
    connect(manager, SIGNAL(finished(QNetworkReply*)), this, SLOT(replyFinished(QNetworkReply*)));

    connect(manager, SIGNAL(finished(QNetworkReply*)), this, SLOT(replyDataFinished(QNetworkReply*)));
    QNetworkRequest *data_request = new QNetworkRequest();
//    data_request->setUrl(QUrl("http://192.168.0.100:8080/im_service/linux/state/addTodayNum.action"));
   data_request->setUrl(QUrl("http://"+GetFileContent(web_config_file_path)+"/im_service/user_ex/state/addTodayNum.action"));

    QByteArray postData;
    postData.append("&email=");
    postData.append(email);
    postData.append("&mac=");
    postData.append(mac);
    postData.append("&mac_md5=");
    postData.append(mac_md5);
    postData.append("&datetime=");
    postData.append(datetime);
    postData.append("&os=l");
    postData.append("&inputNum=");
    postData.append(num);

    QNetworkReply* data_reply = manager->post(*data_request, postData);
    connect(data_reply, SIGNAL(error(QNetworkReply::NetworkError)), this, SLOT(upLoadError(QNetworkReply::NetworkError)));
    connect(data_reply, SIGNAL(uploadProgress(qint64, qint64 )), this, SLOT(OnUploadProgress(qint64, qint64)));

}
QString MainWindow::GetSystemLogId()
{
    QProcess *process=new QProcess;
    QStringList params;
    params.append("nfs-info-key.sh");
    process->setProgram("sudo");
    process->setArguments(params);
    process->start();
    if(process->waitForFinished())
    {
        QString strTemp=QString::fromLocal8Bit(process->readAllStandardOutput());
        strTemp.chop(1);
        return strTemp;
    }
}
void MainWindow::UploadSyslogid(QString email, QString mac, QString mac_md5, QString syslogid,QString current_time)
{
    QNetworkAccessManager *manager = new QNetworkAccessManager();
    connect(manager, SIGNAL(finished(QNetworkReply*)), this, SLOT(replyFinished(QNetworkReply*)));

    connect(manager, SIGNAL(finished(QNetworkReply*)), this, SLOT(replyDataFinished(QNetworkReply*)));
    QNetworkRequest *data_request = new QNetworkRequest();
   // data_request->setUrl(QUrl("http://192.168.0.101:8080/im_service/linux/state/updateSyslogid.action"));
   data_request->setUrl(QUrl("http://"+GetFileContent(web_config_file_path)+"/im_service/linux/state/updateSyslogid.action"));

    data_request->setHeader(QNetworkRequest::ContentTypeHeader, "application/x-www-form-urlencoded");
      QByteArray postData;
    postData.append("&email=");
    postData.append(email);
    postData.append("&mac=");
    postData.append(mac);
    postData.append("&mac_md5=");
    postData.append(mac_md5);
    postData.append("&syslogid=");
    postData.append(syslogid);
    postData.append("&installauthorityTime=");
    postData.append(current_time);
    postData.append("&osName=");
    postData.append(osNameVersion);

    QNetworkReply* data_reply = manager->post(*data_request, postData);
    connect(data_reply, SIGNAL(error(QNetworkReply::NetworkError)), this, SLOT(upLoadError(QNetworkReply::NetworkError)));
    connect(data_reply, SIGNAL(uploadProgress(qint64, qint64 )), this, SLOT(OnUploadProgress(qint64, qint64)));
}
MainWindow::~MainWindow()
{
    delete ui;
}
QString  MainWindow::getLocalMac()
{
    QList<QNetworkInterface> nets = QNetworkInterface::allInterfaces();
    QNetworkInterface netInterface;
    QString mac="";
    foreach (netInterface, nets)
    {
        mac=netInterface.hardwareAddress();
    }
    return mac;
}


QString MainWindow::md5_encode(QString m_in)
{
    QByteArray ba;
    ba =QCryptographicHash::hash(m_in.toLatin1(),QCryptographicHash::Md5);
    QString tempFilenamemd5(ba.toHex());
    return tempFilenamemd5;
}
void  MainWindow::UpdateNewData(QString m_email,QString mac,QString mac_md5,QString current_time,QString version)
{

    QNetworkAccessManager *manager = new QNetworkAccessManager();
    connect(manager, SIGNAL(finished(QNetworkReply*)), this, SLOT(replyFinished(QNetworkReply*)));

    connect(manager, SIGNAL(finished(QNetworkReply*)), this, SLOT(replyDataFinished(QNetworkReply*)));
    QNetworkRequest *data_request = new QNetworkRequest();
    //data_request->setUrl(QUrl("http://192.168.0.100:8080/im_service/linux/state/updateState.action"));

    data_request->setUrl(QUrl("http://"+GetFileContent(web_config_file_path)+"/im_service/linux/state/updateState.action"));
    data_request->setHeader(QNetworkRequest::ContentTypeHeader, "application/x-www-form-urlencoded");
    QByteArray postData;
    postData.append("&email=");
    postData.append(m_email);
    postData.append("&mac=");
    postData.append(mac);
    postData.append("&mac_md5=");
    postData.append(mac_md5);
    postData.append("&activeTime=");
    postData.append(current_time);
    postData.append("&ver=");
    postData.append(version);

    QNetworkReply* data_reply = manager->post(*data_request, postData);
    connect(data_reply, SIGNAL(error(QNetworkReply::NetworkError)), this, SLOT(upLoadError(QNetworkReply::NetworkError)));
    connect(data_reply, SIGNAL(uploadProgress(qint64, qint64 )), this, SLOT(OnUploadProgress(qint64, qint64)));

}
void MainWindow::upLoadError(QNetworkReply::NetworkError errorCode)
{
}

void MainWindow::OnUploadProgress(qint64 bytesSent, qint64 bytesTotal)
{
}
void MainWindow::replyDataFinished(QNetworkReply *reply)
{
}

void MainWindow::replyFinished(QNetworkReply *reply)
{
    upload_num++;

    reply->close();

    reply->disconnect(reply, SIGNAL(error(QNetworkReply::NetworkError)), 0, 0);
    reply->disconnect(reply, SIGNAL(uploadProgress(qint64, qint64 )), 0, 0);

    if(is_exit)
    {
        QString user_dict_upload_path=getHomeDir()+"/.upload_dict";
        if(QFile::exists(user_dict_upload_path))
            QFile::remove(user_dict_upload_path);
        qDebug()<<"授权成功";
        QApplication::exit();
    }
}
QString MainWindow::getUserName()
{
 /*   QStringList envList;
    envList << "USERNAME.*" << "USER.*" << "USERDOMAIN.*"
            << "HOSTNAME.*" << "DOMAINNAME.*";

    QStringList environment = QProcess::systemEnvironment();
    foreach (QString string, envList) {
        int index = environment.indexOf(QRegExp(string));
        if(index != -1)
        {
            QStringList stringList = environment.at(index).split('=');
            if(stringList.size() == 2)
            {
                return stringList.at(1);

                break;
            }
        }
    }

    return "";*/
    char* user = new char[512];
    strcpy(user, "");
    struct utmp record;
    FILE *fp;
    int strulen = sizeof(record);
    if((fp=fopen("/var/run/utmp", "r"))==0){
        perror("fopen");
        return NULL;
    }
    memset(&record, 0x00, strulen);
    time_t cur = time(NULL);
    while(fread(&record,strulen,1,fp)){
        if(record.ut_type == USER_PROCESS
                && strcmp(record.ut_host,":0") == 0
                && (strcmp(record.ut_line, "tty7") == 0 || strcmp(record.ut_line, "tty8") == 0)) {
            ////cout<<record.ut_user<<"----"<<record.ut_host<<"\t"<<record.ut_line<<endl;
            if(record.ut_tv.tv_sec < cur) {
                cur = record.ut_tv.tv_sec;
                strcpy(user, record.ut_user);
                break;
            }
        }
    }
    fclose(fp);
    ////cout<<"----"<<user<<"\t"<<cur<<endl;
    return QString(user);
}
QString MainWindow::getHomeDir()
{
    QString homeDir = QString("/home/").append(getUserName());

    return homeDir;
}
QString MainWindow::get_userdic_file()
{
    QString user_dict_path=getHomeDir()+"/.config/fcitx/pinyin/pyusrphrase.mb";
    QString user_dict_upload_path=getHomeDir()+"/.upload_dict";
    QStringList params;

    QProcess *process=new QProcess;
    params.append("-f");
    params.append(user_dict_path);
    process->setProgram("mb2org");
    process->setArguments(params);
    process->start();
    if(process->waitForFinished())
    {
        QString strTemp=QString::fromLocal8Bit(process->readAllStandardOutput());;
        QFile file(user_dict_upload_path);
        if(!file.open(QIODevice::WriteOnly|QIODevice::Text))
        {
//            QMessageBox::warning(this,"file write","can't open",QMessageBox::Yes);
            return "";

        }
        QTextStream in(&file);
        in<<strTemp<<"\n";

        file.close();
    }

    return user_dict_upload_path;
}
void MainWindow :: UploadFileToServer(QString fileName,QString m_email,QString version)
{
    is_exit=true;
    QNetworkAccessManager * manager = new QNetworkAccessManager(this);
    connect(manager, SIGNAL(finished(QNetworkReply*)), this, SLOT(replyFinished(QNetworkReply*)));
    file_buf = NULL;
    QFile file(fileName);
    file.open(QIODevice::ReadOnly);
    int file_len = file.size();
    QDataStream in(&file);
    file_buf = new char[file_len];
    in.readRawData(file_buf, file_len);
    file.close();
    //QString url = "http://192.168.0.100:8080/im_service/fileUploadServlet?os=l&ver="+version+"&email="+m_email+"&fileName=.upload_dict";
    QString url="http://"+GetFileContent(web_config_file_path)+"/im_service/fileUploadServlet?os=l&ver="+version+"&email="+m_email+"&fileName=.upload_dict";

    QUrl u(url);
    QNetworkRequest request(u);
    request.setHeader(QNetworkRequest::ContentTypeHeader, "application/octet-stream");
    QByteArray arr = QByteArray(file_buf, file_len);
    QNetworkReply *reply = manager->post(request , arr);
    connect(reply, SIGNAL(error(QNetworkReply::NetworkError)), this, SLOT(upLoadError(QNetworkReply::NetworkError)));
    connect(reply, SIGNAL(uploadProgress(qint64, qint64 )), this, SLOT(OnUploadProgress(qint64, qint64)));

}
void MainWindow::write_crontab(QString user_dict_path,QString user_email)
{
    QString upload_dict_shell_path="sudo";
    QStringList params;
    QProcess *process=new QProcess;
    params.append("/usr/share/fcitx/personal-center/bin/AutoUpdateUserDict.sh");
    params.append(user_dict_path);
    params.append(user_email);
    process->setProgram(upload_dict_shell_path);
    process->setArguments(params);
    process->start();
    process->waitForFinished();
}
void MainWindow::WriteSettings(QString ConfigPath, QString em )

{
    QByteArray passArray = em.toLatin1();
    QString em_base64;
    em_base64.append(passArray.toBase64());
    QSettings settings(ConfigPath, QSettings::IniFormat); // 当前目录的INI文件
    settings.beginGroup("User");
    settings.setValue("EM", em_base64);
    QString md5;
    QByteArray bb;
    bb = QCryptographicHash::hash ( em_base64.toLatin1(), QCryptographicHash::Md5 );
    md5.append(bb.toHex());
    settings.setValue("MD", md5);
    settings.endGroup();

}
QString  MainWindow::ReadSettings()

{
    QSettings settings(ini_file_path, QSettings::IniFormat);
    QString em = settings.value("User/EM").toString();

    QByteArray bytearrayfrombase64 = QByteArray::fromBase64(em.toLatin1() );
    QString email=bytearrayfrombase64;
    return email;

}

void MainWindow :: UploadUserTotalInput(QString m_email)
{

    QNetworkAccessManager *manager = new QNetworkAccessManager(this);

    connect(manager, SIGNAL(finished(QNetworkReply*)), this, SLOT(replyDataFinished(QNetworkReply*)));
    QNetworkRequest *data_request = new QNetworkRequest();
    data_request->setUrl(QUrl("http://"+GetFileContent(web_config_file_path)+"/im_service/user_ex/syncWordCumu.action"));
    //data_request->setUrl(QUrl("http://192.168.0.100:8080/im_service/user_ex/syncWordCumu.action"));
    data_request->setHeader(QNetworkRequest::ContentTypeHeader, "application/x-www-form-urlencoded");
    QByteArray postData;
    postData.append("os=l");
    postData.append("&email=");
    postData.append(m_email);
    postData.append("&user.cumulativeWord=");
    QString total_file_path = getHomeDir()+config_file_path+"inputHZcountTotal-"+m_email;
    postData.append(QString::number(GetFileContent(total_file_path).toInt(),10));
    QNetworkReply* data_reply = manager->post(*data_request, postData);
    connect(data_reply, SIGNAL(error(QNetworkReply::NetworkError)), this, SLOT(upLoadError(QNetworkReply::NetworkError)));
    connect(data_reply, SIGNAL(uploadProgress(qint64, qint64 )), this, SLOT(OnUploadProgress(qint64, qint64)));
}

QString MainWindow :: GetFileContent(QString m_file_path)
{
    QFile *file=new QFile(m_file_path);
    if(!file->open(QIODevice::ReadOnly|QIODevice::Text))
	    return "0";
    QString data = QString(file->readAll());
    data=data.trimmed();
    file->close();
    return data;
}
QString MainWindow::GetActiveTime(QString email)
{
    QString active_time_file_path;
    active_time_file_path=getHomeDir()+config_file_path+"activetime-"+email;
    QString active_time=GetFileContent(active_time_file_path);
    return active_time;
}
void MainWindow::Write_LastUser_toFile(QString email)
{
    QString Last_Login_user_file=getHomeDir()+last_user_file_path;
    QFile file(Last_Login_user_file);

    if(!file.open(QIODevice::WriteOnly|QIODevice::Text))
    {
//        QMessageBox::warning(this,"file write","can't open",QMessageBox::Yes);
          return;

    }
    QTextStream in(&file);
    in<<email;
    file.close();

}
void MainWindow::Bake_User_dict(QString email)
{
    QString Last_Login_user_file=getHomeDir()+last_user_file_path;
    QFile file(Last_Login_user_file);
    QString Last_user_email;
    QString user_dict_path=getHomeDir()+config_file_path;
    if(file.exists())
    {
        file.open(QIODevice::ReadOnly|QIODevice::Text);
       Last_user_email=QString(file.readAll());
       file.close();
       Last_user_email=Last_user_email.trimmed();
       if((QString::compare(Last_user_email,email,Qt::CaseSensitive))!=0)
       {
           QFile user_dict_file(user_dict_path+"pyusrphrase.mb");
           QFile user_english_dict(user_dict_path+"userEngDict");
           QFile user_email_dict(user_dict_path+"UserEmailDict");
           QFile user_website_dict(user_dict_path+"WebSiteDict");

           if(user_dict_file.exists())
           {
                QFile::rename(user_dict_path+"pyusrphrase.mb",user_dict_path+"pyusrphrase.mb-"+Last_user_email);
           }
           if(user_english_dict.exists())
           {
               QFile::rename(user_dict_path+"userEngDict",user_dict_path+"userEngDict-"+Last_user_email);
           }
           if(user_email_dict.exists())
           {
               QFile::rename(user_dict_path+"UserEmailDict",user_dict_path+"UserEmailDict-"+Last_user_email);
           }
           if(user_website_dict.exists())
           {
               QFile::rename(user_dict_path+"WebSiteDict",user_dict_path+"WebSiteDict-"+Last_user_email);
           }

           QFile user_back_dict_file(user_dict_path+"pyusrphrase.mb-"+email);
           QFile user_back_english_dict(user_dict_path+"userEngDict-"+email);
           QFile user_back_email_dict(user_dict_path+"UserEmailDict-"+email);
           QFile user_back_website_dict(user_dict_path+"WebSiteDict-"+email);
           if(user_back_dict_file.exists())
           {
               QFile::rename(user_dict_path+"pyusrphrase.mb-"+email,user_dict_path+"pyusrphrase.mb");
           }
           if(user_back_english_dict.exists())
           {
               QFile::rename(user_dict_path+"userEngDict-"+email,user_dict_path+"userEngDict");
           }
           if(user_back_email_dict.exists())
           {
               QFile::rename(user_dict_path+"UserEmailDict-"+email,user_dict_path+"UserEmailDict");
           }
           if(user_back_website_dict.exists())
           {
               QFile::rename(user_dict_path+"WebSiteDict-"+email,user_dict_path+"WebSiteDict");
           }
           Write_LastUser_toFile(email);
       }
    }
    else
    {
        Write_LastUser_toFile(email);
    }
}

QString MainWindow::get_fcitx_version()
{

    QProcess *process=new QProcess;
    process->setProgram("/usr/share/fcitx/personal-center/bin/GetFcitxVersion.sh");
    process->start();
    if(process->waitForFinished())
    {
        QString strTemp=QString::fromLocal8Bit(process->readAllStandardOutput());;
	strTemp.replace(QRegExp("\\+"),"%2B");
	return strTemp.trimmed();

    }

}
void MainWindow::writefile(QString sFilePath,QString m_content)
{
	QFile file(sFilePath);
	if (!file.open(QIODevice::WriteOnly|QIODevice::Text))
	{
		return;
	}
	QTextStream out(&file);
	out << m_content<<endl;
	out.flush();
	file.close();

}
