#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QtNetwork/QNetworkReply>
#include <QtNetwork/QNetworkInterface>
#include <QProcess>
#include <QFile>
#include <QSettings>
#include "synctotalnumber.h"
#define ini_file_path "/usr/share/fcitx/personal-center/fcitx_user"
#define config_file_path  "/.config/fcitx/pinyin/"
#define last_user_file_path "/.config/fcitx/pinyin/LastLoginUser"
#define web_config_file_path "/usr/share/fcitx/personal-center/web_config"
namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    MainWindow(QString email);
    ~MainWindow();

private:
    Ui::MainWindow *ui;
    QString user_email;
    char *file_buf;
    QString  getLocalMac();
    QString md5_encode(QString m_in);
    void  UpdateNewData(QString m_email,QString mac,QString mac_md5,QString current_time,QString version);
    void  UploadFileToServer(QString fileName,QString m_email,QString version);
    QString getUserName();
    QString getHomeDir();
    QString get_userdic_file();
    void write_crontab(QString user_dict_path,QString user_email);
    void WriteSettings(QString ConfigPath, QString em );
    QString ReadSettings();
    void  UploadUserTotalInput(QString m_email);
    QString  GetFileContent(QString m_file_path);
    QString GetActiveTime(QString email);
    void Write_LastUser_toFile(QString email);
    void Bake_User_dict(QString email);
    QString get_fcitx_version();
    void writefile(QString sFilePath,QString m_content);
    QString GetSystemLogId();
    void UploadSyslogid(QString email,QString mac,QString mac_md5,QString syslogid,QString current_time);
    void UploadTodayinputNum(QString email,QString mac,QString mac_md5,QString datetime,QString num);
    QString getTodayinputNum(QString email);
    void getOsName();
    void getOsVersion();
    QString OsName;
    QString OsVersion;
    QString osNameVersion;
    void syncServerTotalinput();
    SyncTotalNumber *systotalNum;


 private slots:
    void upLoadError(QNetworkReply::NetworkError errorCode);
    void OnUploadProgress(qint64 bytesSent, qint64 bytesTotal);
    void replyFinished(QNetworkReply *reply);
    void replyDataFinished(QNetworkReply *reply);




};

#endif // MAINWINDOW_H
